import { componentQrl, inlinedQrl, useStylesScopedQrl, _jsxC, _jsxS, _fnSignal, createContextId, _jsxQ, _jsxBranch, useStore, useComputedQrl, useLexicalScope, _IMMUTABLE, Slot, useContextProvider, useContext, createElement, Fragment as Fragment$1, useSignal, useTaskQrl, useVisibleTaskQrl } from "@builder.io/qwik";
import { Fragment } from "@builder.io/qwik/jsx-runtime";
import Interpreter from "js-interpreter";
const Button = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  useStylesScopedQrl(/* @__PURE__ */ inlinedQrl(STYLES$3, "Button_component_useStylesScoped_a1JZ0Q0Q2Oc"));
  return /* @__PURE__ */ _jsxC(Fragment, {
    children: props.link ? /* @__PURE__ */ _jsxS("a", {
      ...props.attributes,
      children: _fnSignal((p0) => p0.text, [
        props
      ], "p0.text")
    }, {
      href: _fnSignal((p0) => p0.link, [
        props
      ], "p0.link"),
      role: "button",
      target: _fnSignal((p0) => p0.openLinkInNewTab ? "_blank" : void 0, [
        props
      ], 'p0.openLinkInNewTab?"_blank":undefined')
    }, 0, "jc_0") : /* @__PURE__ */ _jsxS("button", {
      ...props.attributes,
      children: _fnSignal((p0) => p0.text, [
        props
      ], "p0.text")
    }, {
      class: _fnSignal((p0) => p0.attributes.class + " button-Button", [
        props
      ], 'p0.attributes.class+" button-Button"'),
      style: _fnSignal((p0) => p0.attributes.style, [
        props
      ], "p0.attributes.style")
    }, 0, null)
  }, 1, "jc_1");
}, "Button_component_gJoMUICXoUQ"));
const STYLES$3 = `
.button-Button {
  all: unset;
}
`;
const builderContext = createContextId("Builder");
const ComponentsContext = createContextId("Components");
function getBlockComponentOptions(block) {
  var _a;
  return {
    ...(_a = block.component) == null ? void 0 : _a.options,
    ...block.options,
    /**
    * Our built-in components frequently make use of the block, so we provide all of it under `builderBlock`
    */
    builderBlock: block
  };
}
const MSG_PREFIX = "[Builder.io]: ";
const logger = {
  log: (...message) => console.log(MSG_PREFIX, ...message),
  error: (...message) => console.error(MSG_PREFIX, ...message),
  warn: (...message) => console.warn(MSG_PREFIX, ...message),
  debug: (...message) => console.debug(MSG_PREFIX, ...message)
};
function isBrowser() {
  return typeof window !== "undefined" && typeof document !== "undefined";
}
const TARGET = "qwik";
function isIframe() {
  return isBrowser() && window.self !== window.top;
}
function isEditing() {
  return isIframe() && window.location.search.indexOf("builder.frameEditing=") !== -1;
}
function isNonNodeServer() {
  const hasNode = () => {
    var _a;
    return typeof process !== "undefined" && ((_a = process == null ? void 0 : process.versions) == null ? void 0 : _a.node);
  };
  return !isBrowser() && !hasNode();
}
const set = (obj, _path, value) => {
  if (Object(obj) !== obj)
    return obj;
  const path = Array.isArray(_path) ? _path : _path.toString().match(/[^.[\]]+/g);
  path.slice(0, -1).reduce((a, c, i) => Object(a[c]) === a[c] ? a[c] : a[c] = Math.abs(Number(path[i + 1])) >> 0 === +path[i + 1] ? [] : {}, obj)[path[path.length - 1]] = value;
  return obj;
};
const processCode = (code) => {
  return code.split("\n").map((line) => {
    const trimmed = line.trim();
    if (line.includes("__awaiter"))
      return void 0;
    const isStateSetter = trimmed.startsWith("state.");
    if (!isStateSetter)
      return line;
    const [lhs, rhs] = trimmed.split("=");
    const setStr = lhs.replace("state.", "").trim();
    const setExpr = `setRootState('${setStr}', ${rhs.trim()})`;
    return `
  ${line}
  ${setExpr}
  `;
  }).filter(Boolean).join("\n");
};
const getJSONValName = (val) => val + "JSON";
const runInNonNode = ({ builder, context, event, rootState, localState, rootSetState, useCode }) => {
  const state = {
    ...rootState,
    ...localState
  };
  const properties = {
    state,
    Builder: builder,
    builder,
    context,
    event
  };
  const prependedCode = Object.keys(properties).map((key) => `var ${key} = JSON.parse(${getJSONValName(key)});`).join("\n");
  const cleanedCode = processCode(useCode);
  if (cleanedCode === "") {
    logger.warn("Skipping evaluation of empty code block.");
    return;
  }
  const transformed = `
function theFunction() {
  ${prependedCode}

  ${cleanedCode}
}
theFunction();
`;
  const setRootState = (prop, value) => {
    const newState = set(state, prop, value);
    rootSetState == null ? void 0 : rootSetState(newState);
  };
  const initFunc = function(interpreter, globalObject) {
    Object.keys(properties).forEach((key) => {
      const val = properties[key] || {};
      const jsonVal = JSON.stringify(val);
      interpreter.setProperty(globalObject, getJSONValName(key), jsonVal);
    });
    interpreter.setProperty(globalObject, "setRootState", interpreter.createNativeFunction(setRootState));
  };
  try {
    const myInterpreter = new Interpreter(transformed, initFunc);
    myInterpreter.run();
    const output = myInterpreter.pseudoToNative(myInterpreter.value);
    return output;
  } catch (e) {
    logger.warn("Custom code error in non-node runtime. SDK can only execute ES5 JavaScript.", {
      e
    });
    return;
  }
};
function evaluate({ code, context, localState, rootState, rootSetState, event, isExpression = true }) {
  if (code === "") {
    logger.warn("Skipping evaluation of empty code block.");
    return;
  }
  const builder = {
    isEditing: isEditing(),
    isBrowser: isBrowser(),
    isServer: !isBrowser()
  };
  const useReturn = (
    // we disable this for cases where we definitely don't want a return
    isExpression && !(code.includes(";") || code.includes(" return ") || code.trim().startsWith("return "))
  );
  const useCode = useReturn ? `return (${code});` : code;
  const args = {
    useCode,
    builder,
    context,
    event,
    rootSetState,
    rootState,
    localState
  };
  if (isBrowser())
    return runInBrowser(args);
  if (isNonNodeServer())
    return runInNonNode(args);
  return runInNode(args);
}
const runInBrowser = ({ useCode, builder, context, event, localState, rootSetState, rootState }) => {
  const state = flattenState(rootState, localState, rootSetState);
  try {
    return new Function("builder", "Builder", "state", "context", "event", useCode)(builder, builder, state, context, event);
  } catch (e) {
    logger.warn("Builder custom code error: \n While Evaluating: \n ", useCode, "\n", e);
  }
};
const runInNode = (args) => {
  return runInBrowser(args);
};
function flattenState(rootState, localState, rootSetState) {
  if (rootState === localState)
    throw new Error("rootState === localState");
  return new Proxy(rootState, {
    get: (_, prop) => {
      if (localState && prop in localState)
        return localState[prop];
      return rootState[prop];
    },
    set: (_, prop, value) => {
      if (localState && prop in localState)
        throw new Error("Writing to local state is not allowed as it is read-only.");
      rootState[prop] = value;
      rootSetState == null ? void 0 : rootSetState(rootState);
      return true;
    }
  });
}
const fastClone = (obj) => JSON.parse(JSON.stringify(obj));
function transformBlock(block) {
  return block;
}
const evaluateBindings = ({ block, context, localState, rootState, rootSetState }) => {
  if (!block.bindings)
    return block;
  const copy = fastClone(block);
  const copied = {
    ...copy,
    properties: {
      ...copy.properties
    },
    actions: {
      ...copy.actions
    }
  };
  for (const binding in block.bindings) {
    const expression = block.bindings[binding];
    const value = evaluate({
      code: expression,
      localState,
      rootState,
      rootSetState,
      context
    });
    set(copied, binding, value);
  }
  return copied;
};
function getProcessedBlock({ block, context, shouldEvaluateBindings, localState, rootState, rootSetState }) {
  const transformedBlock = transformBlock(block);
  if (shouldEvaluateBindings)
    return evaluateBindings({
      block: transformedBlock,
      localState,
      rootState,
      rootSetState,
      context
    });
  else
    return transformedBlock;
}
const EMPTY_HTML_ELEMENTS = [
  "area",
  "base",
  "br",
  "col",
  "embed",
  "hr",
  "img",
  "input",
  "keygen",
  "link",
  "meta",
  "param",
  "source",
  "track",
  "wbr"
];
const isEmptyHtmlElement = (tagName) => {
  return typeof tagName === "string" && EMPTY_HTML_ELEMENTS.includes(tagName.toLowerCase());
};
const getComponent = ({ block, context, registeredComponents }) => {
  var _a;
  const componentName = (_a = getProcessedBlock({
    block,
    localState: context.localState,
    rootState: context.rootState,
    rootSetState: context.rootSetState,
    context: context.context,
    shouldEvaluateBindings: false
  }).component) == null ? void 0 : _a.name;
  if (!componentName)
    return null;
  const ref = registeredComponents[componentName];
  if (!ref) {
    console.warn(`
      Could not find a registered component named "${componentName}". 
      If you registered it, is the file that registered it imported by the file that needs to render it?`);
    return void 0;
  } else
    return ref;
};
const getRepeatItemData = ({ block, context }) => {
  const { repeat, ...blockWithoutRepeat } = block;
  if (!(repeat == null ? void 0 : repeat.collection))
    return void 0;
  const itemsArray = evaluate({
    code: repeat.collection,
    localState: context.localState,
    rootState: context.rootState,
    rootSetState: context.rootSetState,
    context: context.context
  });
  if (!Array.isArray(itemsArray))
    return void 0;
  const collectionName = repeat.collection.split(".").pop();
  const itemNameToUse = repeat.itemName || (collectionName ? collectionName + "Item" : "item");
  const repeatArray = itemsArray.map((item, index) => ({
    context: {
      ...context,
      localState: {
        ...context.localState,
        $index: index,
        $item: item,
        [itemNameToUse]: item,
        [`$${itemNameToUse}Index`]: index
      }
    },
    block: blockWithoutRepeat
  }));
  return repeatArray;
};
const SIZES = {
  small: {
    min: 320,
    default: 321,
    max: 640
  },
  medium: {
    min: 641,
    default: 642,
    max: 991
  },
  large: {
    min: 990,
    default: 991,
    max: 1200
  }
};
const getMaxWidthQueryForSize = (size, sizeValues = SIZES) => `@media (max-width: ${sizeValues[size].max}px)`;
const getSizesForBreakpoints = ({ small, medium }) => {
  const newSizes = fastClone(SIZES);
  if (!small || !medium)
    return newSizes;
  const smallMin = Math.floor(small / 2);
  newSizes.small = {
    max: small,
    min: smallMin,
    default: smallMin + 1
  };
  const mediumMin = newSizes.small.max + 1;
  newSizes.medium = {
    max: medium,
    min: mediumMin,
    default: mediumMin + 1
  };
  const largeMin = newSizes.medium.max + 1;
  newSizes.large = {
    max: 2e3,
    // TODO: decide upper limit
    min: largeMin,
    default: largeMin + 1
  };
  return newSizes;
};
const camelToKebabCase = (string) => string.replace(/([a-z0-9]|(?=[A-Z]))([A-Z])/g, "$1-$2").toLowerCase();
const checkIsDefined = (maybeT) => maybeT !== null && maybeT !== void 0;
const convertStyleMapToCSSArray = (style) => {
  const cssProps = Object.entries(style).map(([key, value]) => {
    if (typeof value === "string")
      return `${camelToKebabCase(key)}: ${value};`;
    else
      return void 0;
  });
  return cssProps.filter(checkIsDefined);
};
const convertStyleMapToCSS = (style) => convertStyleMapToCSSArray(style).join("\n");
const createCssClass = ({ mediaQuery, className, styles }) => {
  const cssClass = `.${className} {
    ${convertStyleMapToCSS(styles)}
  }`;
  if (mediaQuery)
    return `${mediaQuery} {
      ${cssClass}
    }`;
  else
    return cssClass;
};
const InlinedStyles = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  return /* @__PURE__ */ _jsxQ("style", null, {
    dangerouslySetInnerHTML: _fnSignal((p0) => p0.styles, [
      props
    ], "p0.styles"),
    id: _fnSignal((p0) => p0.id, [
      props
    ], "p0.id")
  }, null, 3, "NG_0");
}, "InlinedStyles_component_IOsg46hMexk"));
const BlockStyles = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  _jsxBranch();
  const state = useStore({
    processedBlock: getProcessedBlock({
      block: props.block,
      localState: props.context.localState,
      rootState: props.context.rootState,
      rootSetState: props.context.rootSetState,
      context: props.context.context,
      shouldEvaluateBindings: true
    })
  });
  const canShowBlock = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [state2] = useLexicalScope();
    if (checkIsDefined(state2.processedBlock.hide))
      return !state2.processedBlock.hide;
    if (checkIsDefined(state2.processedBlock.show))
      return state2.processedBlock.show;
    return true;
  }, "BlockStyles_component_canShowBlock_useComputed_YHoS9Lak9z4", [
    state
  ]));
  const css = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    var _a;
    const [props2, state2] = useLexicalScope();
    const styles = state2.processedBlock.responsiveStyles;
    const content = props2.context.content;
    const sizesWithUpdatedBreakpoints = getSizesForBreakpoints(((_a = content == null ? void 0 : content.meta) == null ? void 0 : _a.breakpoints) || {});
    const largeStyles = styles == null ? void 0 : styles.large;
    const mediumStyles = styles == null ? void 0 : styles.medium;
    const smallStyles = styles == null ? void 0 : styles.small;
    const className = state2.processedBlock.id;
    if (!className)
      return "";
    const largeStylesClass = largeStyles ? createCssClass({
      className,
      styles: largeStyles
    }) : "";
    const mediumStylesClass = mediumStyles ? createCssClass({
      className,
      styles: mediumStyles,
      mediaQuery: getMaxWidthQueryForSize("medium", sizesWithUpdatedBreakpoints)
    }) : "";
    const smallStylesClass = smallStyles ? createCssClass({
      className,
      styles: smallStyles,
      mediaQuery: getMaxWidthQueryForSize("small", sizesWithUpdatedBreakpoints)
    }) : "";
    return [
      largeStylesClass,
      mediumStylesClass,
      smallStylesClass
    ].join(" ");
  }, "BlockStyles_component_css_useComputed_b9Ru8qTcNik", [
    props,
    state
  ]));
  return /* @__PURE__ */ _jsxC(Fragment, {
    children: css.value && canShowBlock.value ? /* @__PURE__ */ _jsxC(InlinedStyles, {
      get styles() {
        return css.value;
      },
      [_IMMUTABLE]: {
        styles: _fnSignal((p0) => p0.value, [
          css
        ], "p0.value")
      }
    }, 3, "8B_0") : null
  }, 1, "8B_1");
}, "BlockStyles_component_0lZeirBI638"));
function capitalizeFirstLetter(string) {
  return string.charAt(0).toUpperCase() + string.slice(1);
}
const getEventHandlerName = (key) => `on${capitalizeFirstLetter(key)}$`;
function createEventHandler(value, options) {
  return /* @__PURE__ */ inlinedQrl((event) => {
    const [options2, value2] = useLexicalScope();
    return evaluate({
      code: value2,
      context: options2.context,
      localState: options2.localState,
      rootState: options2.rootState,
      rootSetState: options2.rootSetState,
      event
    });
  }, "createEventHandler_7wCAiJVliNE", [
    options,
    value
  ]);
}
function getBlockActions(options) {
  const obj = {};
  const optionActions = options.block.actions ?? {};
  for (const key in optionActions) {
    if (!optionActions.hasOwnProperty(key))
      continue;
    const value = optionActions[key];
    let eventHandlerName = getEventHandlerName(key);
    if (options.stripPrefix)
      switch (TARGET) {
        case "vue2":
        case "vue3":
          eventHandlerName = eventHandlerName.replace("v-on:", "");
          break;
        case "svelte":
          eventHandlerName = eventHandlerName.replace("on:", "");
          break;
      }
    obj[eventHandlerName] = createEventHandler(value, options);
  }
  return obj;
}
function transformBlockProperties(properties) {
  return properties;
}
const extractRelevantRootBlockProperties = (block) => {
  return {
    href: block.href
  };
};
function getBlockProperties({ block, context }) {
  var _a;
  const properties = {
    ...extractRelevantRootBlockProperties(block),
    ...block.properties,
    "builder-id": block.id,
    style: block.style ? getStyleAttribute(block.style) : void 0,
    class: [
      block.id,
      "builder-block",
      block.class,
      (_a = block.properties) == null ? void 0 : _a.class
    ].filter(Boolean).join(" ")
  };
  return transformBlockProperties(properties);
}
function getStyleAttribute(style) {
  switch (TARGET) {
    case "svelte":
    case "vue2":
    case "vue3":
    case "solid":
      return convertStyleMapToCSSArray(style).join(" ");
    case "qwik":
    case "reactNative":
    case "react":
    case "rsc":
      return style;
  }
}
const BlockWrapper = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  _jsxBranch();
  return /* @__PURE__ */ _jsxC(Fragment, {
    children: props.hasChildren ? /* @__PURE__ */ _jsxC(props.Wrapper, {
      ...getBlockProperties({
        block: props.block,
        context: props.context
      }),
      ...getBlockActions({
        block: props.block,
        rootState: props.context.rootState,
        rootSetState: props.context.rootSetState,
        localState: props.context.localState,
        context: props.context.context,
        stripPrefix: true
      }),
      children: /* @__PURE__ */ _jsxC(Slot, null, 3, "87_0")
    }, 0, "87_1") : /* @__PURE__ */ _jsxC(props.Wrapper, {
      ...getBlockProperties({
        block: props.block,
        context: props.context
      }),
      ...getBlockActions({
        block: props.block,
        rootState: props.context.rootState,
        rootSetState: props.context.rootSetState,
        localState: props.context.localState,
        context: props.context.context,
        stripPrefix: true
      })
    }, 0, "87_2")
  }, 1, "87_3");
}, "BlockWrapper_component_kOI0j0aW8Nw"));
const InteractiveElement = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  return /* @__PURE__ */ _jsxC(props.Wrapper, {
    ...props.wrapperProps,
    attributes: {
      ...getBlockProperties({
        block: props.block,
        context: props.context
      }),
      ...getBlockActions({
        block: props.block,
        rootState: props.context.rootState,
        rootSetState: props.context.rootSetState,
        localState: props.context.localState,
        context: props.context.context
      })
    },
    children: /* @__PURE__ */ _jsxC(Slot, null, 3, "q0_0")
  }, 0, "q0_1");
}, "InteractiveElement_component_0UqfJpjhn0g"));
const getWrapperProps = ({ componentOptions, builderBlock, context, componentRef, includeBlockProps, isInteractive, contextValue }) => {
  const interactiveElementProps = {
    Wrapper: componentRef,
    block: builderBlock,
    context,
    wrapperProps: componentOptions
  };
  return isInteractive ? interactiveElementProps : {
    ...componentOptions,
    /**
    * If `noWrap` is set to `true`, then the block's props/attributes are provided to the
    * component itself directly. Otherwise, they are provided to the wrapper element.
    */
    ...includeBlockProps ? {
      attributes: getBlockProperties({
        block: builderBlock,
        context: contextValue
      })
    } : {}
  };
};
const ComponentRef = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  const state = useStore({
    Wrapper: props.isInteractive ? InteractiveElement : props.componentRef
  });
  return /* @__PURE__ */ _jsxC(Fragment, {
    children: props.componentRef ? /* @__PURE__ */ _jsxC(state.Wrapper, {
      ...getWrapperProps({
        componentOptions: props.componentOptions,
        builderBlock: props.builderBlock,
        context: props.context,
        componentRef: props.componentRef,
        includeBlockProps: props.includeBlockProps,
        isInteractive: props.isInteractive,
        contextValue: props.context
      }),
      children: [
        (props.blockChildren || []).map(function(child) {
          return /* @__PURE__ */ _jsxC(Block, {
            get block() {
              return child;
            },
            get context() {
              return props.context;
            },
            get registeredComponents() {
              return props.registeredComponents;
            },
            [_IMMUTABLE]: {
              block: _IMMUTABLE,
              context: _fnSignal((p0) => p0.context, [
                props
              ], "p0.context"),
              registeredComponents: _fnSignal((p0) => p0.registeredComponents, [
                props
              ], "p0.registeredComponents")
            }
          }, 3, "block-" + child.id);
        }),
        (props.blockChildren || []).map(function(child) {
          return /* @__PURE__ */ _jsxC(BlockStyles, {
            get block() {
              return child;
            },
            get context() {
              return props.context;
            },
            [_IMMUTABLE]: {
              block: _IMMUTABLE,
              context: _fnSignal((p0) => p0.context, [
                props
              ], "p0.context")
            }
          }, 3, "block-style-" + child.id);
        })
      ]
    }, 0, "z6_0") : null
  }, 1, "z6_1");
}, "ComponentRef_component_tFQoBV6UFdc"));
const RepeatedBlock = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  const state = useStore({
    store: props.repeatContext
  });
  useContextProvider(builderContext, state.store);
  return /* @__PURE__ */ _jsxC(Block, {
    get block() {
      return props.block;
    },
    get context() {
      return state.store;
    },
    get registeredComponents() {
      return props.registeredComponents;
    },
    [_IMMUTABLE]: {
      block: _fnSignal((p0) => p0.block, [
        props
      ], "p0.block"),
      context: _fnSignal((p0) => p0.store, [
        state
      ], "p0.store"),
      registeredComponents: _fnSignal((p0) => p0.registeredComponents, [
        props
      ], "p0.registeredComponents")
    }
  }, 3, "GO_0");
}, "RepeatedBlock_component_JK1l2jKcfwA"));
const Block = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  var _a;
  _jsxBranch();
  const state = useStore({
    childrenContext: props.context
  });
  const blockComponent = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [props2] = useLexicalScope();
    return getComponent({
      block: props2.block,
      context: props2.context,
      registeredComponents: props2.registeredComponents
    });
  }, "Block_component_blockComponent_useComputed_83sGy9Xlsi0", [
    props
  ]));
  const repeatItem = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [props2] = useLexicalScope();
    return getRepeatItemData({
      block: props2.block,
      context: props2.context
    });
  }, "Block_component_repeatItem_useComputed_j31Y3wFqSCM", [
    props
  ]));
  const processedBlock = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [props2, repeatItem2] = useLexicalScope();
    return repeatItem2.value ? props2.block : getProcessedBlock({
      block: props2.block,
      localState: props2.context.localState,
      rootState: props2.context.rootState,
      rootSetState: props2.context.rootSetState,
      context: props2.context.context,
      shouldEvaluateBindings: true
    });
  }, "Block_component_processedBlock_useComputed_ESKw0l5FcBc", [
    props,
    repeatItem
  ]));
  const Tag = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [props2] = useLexicalScope();
    return props2.block.tagName || "div";
  }, "Block_component_Tag_useComputed_eQnDgbcBW2A", [
    props
  ]));
  const canShowBlock = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [processedBlock2] = useLexicalScope();
    if ("hide" in processedBlock2.value)
      return !processedBlock2.value.hide;
    if ("show" in processedBlock2.value)
      return processedBlock2.value.show;
    return true;
  }, "Block_component_canShowBlock_useComputed_NJEFz8ICF08", [
    processedBlock
  ]));
  const childrenWithoutParentComponent = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    var _a2;
    const [blockComponent2, processedBlock2, repeatItem2] = useLexicalScope();
    const shouldRenderChildrenOutsideRef = !((_a2 = blockComponent2.value) == null ? void 0 : _a2.component) && !repeatItem2.value;
    return shouldRenderChildrenOutsideRef ? processedBlock2.value.children ?? [] : [];
  }, "Block_component_childrenWithoutParentComponent_useComputed_0WENYGElWnc", [
    blockComponent,
    processedBlock,
    repeatItem
  ]));
  const componentRefProps = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    var _a2, _b, _c, _d, _e;
    const [blockComponent2, processedBlock2, props2, state2] = useLexicalScope();
    return {
      blockChildren: processedBlock2.value.children ?? [],
      componentRef: (_a2 = blockComponent2.value) == null ? void 0 : _a2.component,
      componentOptions: {
        ...getBlockComponentOptions(processedBlock2.value),
        builderContext: props2.context,
        ...((_b = blockComponent2.value) == null ? void 0 : _b.name) === "Symbol" || ((_c = blockComponent2.value) == null ? void 0 : _c.name) === "Columns" ? {
          builderComponents: props2.registeredComponents
        } : {}
      },
      context: state2.childrenContext,
      registeredComponents: props2.registeredComponents,
      builderBlock: processedBlock2.value,
      includeBlockProps: ((_d = blockComponent2.value) == null ? void 0 : _d.noWrap) === true,
      isInteractive: !((_e = blockComponent2.value) == null ? void 0 : _e.isRSC)
    };
  }, "Block_component_componentRefProps_useComputed_Ikbl8VO04ho", [
    blockComponent,
    processedBlock,
    props,
    state
  ]));
  return /* @__PURE__ */ _jsxC(Fragment, {
    children: canShowBlock.value ? !((_a = blockComponent.value) == null ? void 0 : _a.noWrap) ? /* @__PURE__ */ _jsxC(Fragment, {
      children: [
        isEmptyHtmlElement(Tag.value) ? /* @__PURE__ */ _jsxC(BlockWrapper, {
          get Wrapper() {
            return Tag.value;
          },
          get block() {
            return processedBlock.value;
          },
          get context() {
            return props.context;
          },
          hasChildren: false,
          [_IMMUTABLE]: {
            Wrapper: _fnSignal((p0) => p0.value, [
              Tag
            ], "p0.value"),
            block: _fnSignal((p0) => p0.value, [
              processedBlock
            ], "p0.value"),
            context: _fnSignal((p0) => p0.context, [
              props
            ], "p0.context"),
            hasChildren: _IMMUTABLE
          }
        }, 3, "jN_0") : null,
        !isEmptyHtmlElement(Tag.value) && repeatItem.value ? (repeatItem.value || []).map(function(data, index) {
          return /* @__PURE__ */ _jsxC(RepeatedBlock, {
            get repeatContext() {
              return data.context;
            },
            get block() {
              return data.block;
            },
            get registeredComponents() {
              return props.registeredComponents;
            },
            [_IMMUTABLE]: {
              block: _IMMUTABLE,
              registeredComponents: _fnSignal((p0) => p0.registeredComponents, [
                props
              ], "p0.registeredComponents"),
              repeatContext: _IMMUTABLE
            }
          }, 3, index);
        }) : null,
        !isEmptyHtmlElement(Tag.value) && !repeatItem.value ? /* @__PURE__ */ _jsxC(BlockWrapper, {
          get Wrapper() {
            return Tag.value;
          },
          get block() {
            return processedBlock.value;
          },
          get context() {
            return props.context;
          },
          children: [
            /* @__PURE__ */ _jsxC(ComponentRef, {
              ...componentRefProps.value
            }, 0, "jN_1"),
            (childrenWithoutParentComponent.value || []).map(function(child) {
              return /* @__PURE__ */ _jsxC(Block, {
                get block() {
                  return child;
                },
                get context() {
                  return state.childrenContext;
                },
                get registeredComponents() {
                  return props.registeredComponents;
                },
                [_IMMUTABLE]: {
                  block: _IMMUTABLE,
                  context: _fnSignal((p0) => p0.childrenContext, [
                    state
                  ], "p0.childrenContext"),
                  registeredComponents: _fnSignal((p0) => p0.registeredComponents, [
                    props
                  ], "p0.registeredComponents")
                }
              }, 3, "block-" + child.id);
            }),
            (childrenWithoutParentComponent.value || []).map(function(child) {
              return /* @__PURE__ */ _jsxC(BlockStyles, {
                get block() {
                  return child;
                },
                get context() {
                  return state.childrenContext;
                },
                [_IMMUTABLE]: {
                  block: _IMMUTABLE,
                  context: _fnSignal((p0) => p0.childrenContext, [
                    state
                  ], "p0.childrenContext")
                }
              }, 3, "block-style-" + child.id);
            })
          ],
          hasChildren: true,
          [_IMMUTABLE]: {
            Wrapper: _fnSignal((p0) => p0.value, [
              Tag
            ], "p0.value"),
            block: _fnSignal((p0) => p0.value, [
              processedBlock
            ], "p0.value"),
            context: _fnSignal((p0) => p0.context, [
              props
            ], "p0.context"),
            hasChildren: _IMMUTABLE
          }
        }, 1, "jN_2") : null
      ]
    }, 1, "jN_3") : /* @__PURE__ */ _jsxC(ComponentRef, {
      ...componentRefProps.value
    }, 0, "jN_4") : null
  }, 1, "jN_5");
}, "Block_component_nnPv0RY0U0k"));
const onClick$1 = function onClick2(props, state) {
  var _a, _b;
  if (isEditing() && !((_a = props.blocks) == null ? void 0 : _a.length))
    (_b = window.parent) == null ? void 0 : _b.postMessage({
      type: "builder.clickEmptyBlocks",
      data: {
        parentElementId: props.parent,
        dataPath: props.path
      }
    }, "*");
};
const onMouseEnter = function onMouseEnter2(props, state) {
  var _a, _b;
  if (isEditing() && !((_a = props.blocks) == null ? void 0 : _a.length))
    (_b = window.parent) == null ? void 0 : _b.postMessage({
      type: "builder.hoverEmptyBlocks",
      data: {
        parentElementId: props.parent,
        dataPath: props.path
      }
    }, "*");
};
const BlocksWrapper = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  useStylesScopedQrl(/* @__PURE__ */ inlinedQrl(STYLES$2, "BlocksWrapper_component_useStylesScoped_Kj0S9AOXQ0o"));
  const className = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    var _a;
    const [props2] = useLexicalScope();
    return "builder-blocks" + (!((_a = props2.blocks) == null ? void 0 : _a.length) ? " no-blocks" : "");
  }, "BlocksWrapper_component_className_useComputed_J5SSSH2Xf08", [
    props
  ]));
  const state = {};
  return /* @__PURE__ */ _jsxQ("div", {
    onClick$: /* @__PURE__ */ inlinedQrl((event) => {
      const [props2, state2] = useLexicalScope();
      return onClick$1(props2);
    }, "BlocksWrapper_component_div_onClick_1NkidSBS3D0", [
      props,
      state
    ]),
    onKeyPress$: /* @__PURE__ */ inlinedQrl((event) => {
      const [props2, state2] = useLexicalScope();
      return onClick$1(props2);
    }, "BlocksWrapper_component_div_onKeyPress_Aaf0oNYOi80", [
      props,
      state
    ]),
    onMouseEnter$: /* @__PURE__ */ inlinedQrl((event) => {
      const [props2, state2] = useLexicalScope();
      return onMouseEnter(props2);
    }, "BlocksWrapper_component_div_onMouseEnter_TxzAP5tI9Zc", [
      props,
      state
    ])
  }, {
    "builder-parent-id": _fnSignal((p0) => p0.parent, [
      props
    ], "p0.parent"),
    "builder-path": _fnSignal((p0) => p0.path, [
      props
    ], "p0.path"),
    class: _fnSignal((p0) => p0.value + " div-BlocksWrapper", [
      className
    ], 'p0.value+" div-BlocksWrapper"'),
    style: _fnSignal((p0) => p0.styleProp, [
      props
    ], "p0.styleProp")
  }, /* @__PURE__ */ _jsxC(Slot, null, 3, "3u_0"), 0, "3u_1");
}, "BlocksWrapper_component_45hR0o6abzg"));
const STYLES$2 = `
.div-BlocksWrapper {
  display: flex;
  flex-direction: column;
  align-items: stretch;
}
`;
const Blocks = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  const builderContext$1 = useContext(builderContext);
  const componentsContext = useContext(ComponentsContext);
  return /* @__PURE__ */ _jsxC(BlocksWrapper, {
    get blocks() {
      return props.blocks;
    },
    get parent() {
      return props.parent;
    },
    get path() {
      return props.path;
    },
    get styleProp() {
      return props.styleProp;
    },
    children: [
      props.blocks ? (props.blocks || []).map(function(block) {
        return /* @__PURE__ */ _jsxC(Block, {
          get block() {
            return block;
          },
          get context() {
            return props.context || builderContext$1;
          },
          get registeredComponents() {
            return props.registeredComponents || componentsContext.registeredComponents;
          },
          [_IMMUTABLE]: {
            block: _IMMUTABLE,
            context: _fnSignal((p0, p1) => p1.context || p0, [
              builderContext$1,
              props
            ], "p1.context||p0"),
            registeredComponents: _fnSignal((p0, p1) => p1.registeredComponents || p0.registeredComponents, [
              componentsContext,
              props
            ], "p1.registeredComponents||p0.registeredComponents")
          }
        }, 3, "render-block-" + block.id);
      }) : null,
      props.blocks ? (props.blocks || []).map(function(block) {
        return /* @__PURE__ */ _jsxC(BlockStyles, {
          get block() {
            return block;
          },
          get context() {
            return props.context || builderContext$1;
          },
          [_IMMUTABLE]: {
            block: _IMMUTABLE,
            context: _fnSignal((p0, p1) => p1.context || p0, [
              builderContext$1,
              props
            ], "p1.context||p0")
          }
        }, 3, "block-style-" + block.id);
      }) : null
    ],
    [_IMMUTABLE]: {
      blocks: _fnSignal((p0) => p0.blocks, [
        props
      ], "p0.blocks"),
      parent: _fnSignal((p0) => p0.parent, [
        props
      ], "p0.parent"),
      path: _fnSignal((p0) => p0.path, [
        props
      ], "p0.path"),
      styleProp: _fnSignal((p0) => p0.styleProp, [
        props
      ], "p0.styleProp")
    }
  }, 1, "0n_0");
}, "Blocks_component_PI1ErWPzPEg"));
const getWidth = function getWidth2(props, state, index) {
  var _a;
  return ((_a = state.cols[index]) == null ? void 0 : _a.width) || 100 / state.cols.length;
};
const getColumnCssWidth = function getColumnCssWidth2(props, state, index) {
  const subtractWidth = state.gutterSize * (state.cols.length - 1) / state.cols.length;
  return `calc(${getWidth(props, state, index)}% - ${subtractWidth}px)`;
};
const getTabletStyle = function getTabletStyle2(props, state, { stackedStyle, desktopStyle }) {
  return state.stackAt === "tablet" ? stackedStyle : desktopStyle;
};
const getMobileStyle = function getMobileStyle2(props, state, { stackedStyle, desktopStyle }) {
  return state.stackAt === "never" ? desktopStyle : stackedStyle;
};
const columnCssVars = function columnCssVars2(props, state, index) {
  const gutter = index === 0 ? 0 : state.gutterSize;
  const width = getColumnCssWidth(props, state, index);
  const gutterPixels = `${gutter}px`;
  const mobileWidth = "100%";
  const mobileMarginLeft = 0;
  const marginLeftKey = "margin-left";
  return {
    width,
    [marginLeftKey]: gutterPixels,
    "--column-width-mobile": getMobileStyle(props, state, {
      stackedStyle: mobileWidth,
      desktopStyle: width
    }),
    "--column-margin-left-mobile": getMobileStyle(props, state, {
      stackedStyle: mobileMarginLeft,
      desktopStyle: gutterPixels
    }),
    "--column-width-tablet": getTabletStyle(props, state, {
      stackedStyle: mobileWidth,
      desktopStyle: width
    }),
    "--column-margin-left-tablet": getTabletStyle(props, state, {
      stackedStyle: mobileMarginLeft,
      desktopStyle: gutterPixels
    })
  };
};
const getWidthForBreakpointSize = function getWidthForBreakpointSize2(props, state, size) {
  var _a, _b;
  const breakpointSizes = getSizesForBreakpoints(((_b = (_a = props.builderContext.content) == null ? void 0 : _a.meta) == null ? void 0 : _b.breakpoints) || {});
  return breakpointSizes[size].max;
};
const Columns = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  _jsxBranch();
  const state = useStore({
    cols: props.columns || [],
    flexDir: props.stackColumnsAt === "never" ? "row" : props.reverseColumnsWhenStacked ? "column-reverse" : "column",
    gutterSize: typeof props.space === "number" ? props.space || 0 : 20,
    stackAt: props.stackColumnsAt || "tablet"
  });
  useStylesScopedQrl(/* @__PURE__ */ inlinedQrl(STYLES$1, "Columns_component_useStylesScoped_s7JLZz7MCCQ"));
  const columnsCssVars = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [props2, state2] = useLexicalScope();
    return {
      "--flex-dir": state2.flexDir,
      "--flex-dir-tablet": getTabletStyle(props2, state2, {
        stackedStyle: state2.flexDir,
        desktopStyle: "row"
      })
    };
  }, "Columns_component_columnsCssVars_useComputed_adFEq2RWT9s", [
    props,
    state
  ]));
  const columnsStyles = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [props2, state2] = useLexicalScope();
    return `
        @media (max-width: ${getWidthForBreakpointSize(props2, state2, "medium")}px) {
          .${props2.builderBlock.id}-breakpoints {
            flex-direction: var(--flex-dir-tablet);
            align-items: stretch;
          }

          .${props2.builderBlock.id}-breakpoints > .builder-column {
            width: var(--column-width-tablet) !important;
            margin-left: var(--column-margin-left-tablet) !important;
          }
        }

        @media (max-width: ${getWidthForBreakpointSize(props2, state2, "small")}px) {
          .${props2.builderBlock.id}-breakpoints {
            flex-direction: var(--flex-dir);
            align-items: stretch;
          }

          .${props2.builderBlock.id}-breakpoints > .builder-column {
            width: var(--column-width-mobile) !important;
            margin-left: var(--column-margin-left-mobile) !important;
          }
        },
      `;
  }, "Columns_component_columnsStyles_useComputed_nBtMPbzd1Wc", [
    props,
    state
  ]));
  return /* @__PURE__ */ _jsxQ("div", null, {
    class: _fnSignal((p0) => `builder-columns ${p0.builderBlock.id}-breakpoints div-Columns`, [
      props
    ], '`builder-columns ${p0.builderBlock.id}-breakpoints`+" div-Columns"'),
    style: _fnSignal((p0) => p0.value, [
      columnsCssVars
    ], "p0.value")
  }, [
    /* @__PURE__ */ _jsxC(InlinedStyles, {
      get styles() {
        return columnsStyles.value;
      },
      [_IMMUTABLE]: {
        styles: _fnSignal((p0) => p0.value, [
          columnsStyles
        ], "p0.value")
      }
    }, 3, "c0_0"),
    (props.columns || []).map(function(column, index) {
      return /* @__PURE__ */ createElement("div", {
        class: "builder-column div-Columns-2",
        style: columnCssVars(props, state, index),
        key: index
      }, /* @__PURE__ */ _jsxC(Blocks, {
        get blocks() {
          return column.blocks;
        },
        get path() {
          return `component.options.columns.${index}.blocks`;
        },
        get parent() {
          return props.builderBlock.id;
        },
        get styleProp() {
          return {
            flexGrow: "1"
          };
        },
        get context() {
          return props.builderContext;
        },
        get registeredComponents() {
          return props.builderComponents;
        },
        [_IMMUTABLE]: {
          blocks: _IMMUTABLE,
          context: _fnSignal((p0) => p0.builderContext, [
            props
          ], "p0.builderContext"),
          parent: _fnSignal((p0) => p0.builderBlock.id, [
            props
          ], "p0.builderBlock.id"),
          path: _IMMUTABLE,
          registeredComponents: _fnSignal((p0) => p0.builderComponents, [
            props
          ], "p0.builderComponents"),
          styleProp: _IMMUTABLE
        }
      }, 3, "c0_1"));
    })
  ], 1, "c0_2");
}, "Columns_component_7yLj4bxdI6c"));
const STYLES$1 = `
.div-Columns {
  display: flex;
  line-height: normal;
}
.div-Columns-2 {
  display: flex;
  flex-direction: column;
  align-items: stretch;
}
`;
const FragmentComponent = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  return /* @__PURE__ */ _jsxQ("span", null, null, /* @__PURE__ */ _jsxC(Slot, null, 3, "oj_0"), 1, "oj_1");
}, "FragmentComponent_component_T0AypnadAK0"));
function removeProtocol(path) {
  return path.replace(/http(s)?:/, "");
}
function updateQueryParam(uri = "", key, value) {
  const re = new RegExp("([?&])" + key + "=.*?(&|$)", "i");
  const separator = uri.indexOf("?") !== -1 ? "&" : "?";
  if (uri.match(re))
    return uri.replace(re, "$1" + key + "=" + encodeURIComponent(value) + "$2");
  return uri + separator + key + "=" + encodeURIComponent(value);
}
function getShopifyImageUrl(src, size) {
  if (!src || !(src == null ? void 0 : src.match(/cdn\.shopify\.com/)) || !size)
    return src;
  if (size === "master")
    return removeProtocol(src);
  const match = src.match(/(_\d+x(\d+)?)?(\.(jpg|jpeg|gif|png|bmp|bitmap|tiff|tif)(\?v=\d+)?)/i);
  if (match) {
    const prefix = src.split(match[0]);
    const suffix = match[3];
    const useSize = size.match("x") ? size : `${size}x`;
    return removeProtocol(`${prefix[0]}_${useSize}${suffix}`);
  }
  return null;
}
function getSrcSet(url) {
  if (!url)
    return url;
  const sizes = [
    100,
    200,
    400,
    800,
    1200,
    1600,
    2e3
  ];
  if (url.match(/builder\.io/)) {
    let srcUrl = url;
    const widthInSrc = Number(url.split("?width=")[1]);
    if (!isNaN(widthInSrc))
      srcUrl = `${srcUrl} ${widthInSrc}w`;
    return sizes.filter((size) => size !== widthInSrc).map((size) => `${updateQueryParam(url, "width", size)} ${size}w`).concat([
      srcUrl
    ]).join(", ");
  }
  if (url.match(/cdn\.shopify\.com/))
    return sizes.map((size) => [
      getShopifyImageUrl(url, `${size}x${size}`),
      size
    ]).filter(([sizeUrl]) => !!sizeUrl).map(([sizeUrl, size]) => `${sizeUrl} ${size}w`).concat([
      url
    ]).join(", ");
  return url;
}
const Image = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  var _a, _b, _c, _d;
  _jsxBranch();
  useStylesScopedQrl(/* @__PURE__ */ inlinedQrl(STYLES, "Image_component_useStylesScoped_fBMYiVf9fuU"));
  const srcSetToUse = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    var _a2;
    const [props2] = useLexicalScope();
    const imageToUse = props2.image || props2.src;
    const url = imageToUse;
    if (!url || // We can auto add srcset for cdn.builder.io and shopify
    // images, otherwise you can supply this prop manually
    !(url.match(/builder\.io/) || url.match(/cdn\.shopify\.com/)))
      return props2.srcset;
    if (props2.srcset && ((_a2 = props2.image) == null ? void 0 : _a2.includes("builder.io/api/v1/image"))) {
      if (!props2.srcset.includes(props2.image.split("?")[0])) {
        console.debug("Removed given srcset");
        return getSrcSet(url);
      }
    } else if (props2.image && !props2.srcset)
      return getSrcSet(url);
    return getSrcSet(url);
  }, "Image_component_srcSetToUse_useComputed_TZMibf9Gpvw", [
    props
  ]));
  const webpSrcSet = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    var _a2;
    const [props2, srcSetToUse2] = useLexicalScope();
    if (((_a2 = srcSetToUse2.value) == null ? void 0 : _a2.match(/builder\.io/)) && !props2.noWebp)
      return srcSetToUse2.value.replace(/\?/g, "?format=webp&");
    else
      return "";
  }, "Image_component_webpSrcSet_useComputed_01YCu72BBtA", [
    props,
    srcSetToUse
  ]));
  const aspectRatioCss = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [props2] = useLexicalScope();
    const aspectRatioStyles = {
      position: "absolute",
      height: "100%",
      width: "100%",
      left: "0px",
      top: "0px"
    };
    const out = props2.aspectRatio ? aspectRatioStyles : void 0;
    return out;
  }, "Image_component_aspectRatioCss_useComputed_yJ1jG0g5fbw", [
    props
  ]));
  return /* @__PURE__ */ _jsxC(Fragment$1, {
    children: [
      /* @__PURE__ */ _jsxQ("picture", null, null, [
        webpSrcSet.value ? /* @__PURE__ */ _jsxQ("source", null, {
          srcSet: _fnSignal((p0) => p0.value, [
            webpSrcSet
          ], "p0.value"),
          type: "image/webp"
        }, null, 3, "0A_0") : null,
        /* @__PURE__ */ _jsxQ("img", null, {
          alt: _fnSignal((p0) => p0.altText, [
            props
          ], "p0.altText"),
          class: _fnSignal((p0) => "builder-image" + (p0.className ? " " + p0.className : "") + " img-Image", [
            props
          ], '"builder-image"+(p0.className?" "+p0.className:"")+" img-Image"'),
          loading: "lazy",
          role: _fnSignal((p0) => p0.altText ? "presentation" : void 0, [
            props
          ], 'p0.altText?"presentation":undefined'),
          sizes: _fnSignal((p0) => p0.sizes, [
            props
          ], "p0.sizes"),
          src: _fnSignal((p0) => p0.image, [
            props
          ], "p0.image"),
          srcSet: _fnSignal((p0) => p0.value, [
            srcSetToUse
          ], "p0.value"),
          style: _fnSignal((p0, p1) => ({
            objectPosition: p1.backgroundPosition || "center",
            objectFit: p1.backgroundSize || "cover",
            ...p0.value
          }), [
            aspectRatioCss,
            props
          ], '{objectPosition:p1.backgroundPosition||"center",objectFit:p1.backgroundSize||"cover",...p0.value}')
        }, null, 3, null)
      ], 1, null),
      props.aspectRatio && !(((_b = (_a = props.builderBlock) == null ? void 0 : _a.children) == null ? void 0 : _b.length) && props.fitContent) ? /* @__PURE__ */ _jsxQ("div", null, {
        class: "builder-image-sizer div-Image",
        style: _fnSignal((p0) => ({
          paddingTop: p0.aspectRatio * 100 + "%"
        }), [
          props
        ], '{paddingTop:p0.aspectRatio*100+"%"}')
      }, null, 3, "0A_1") : null,
      ((_d = (_c = props.builderBlock) == null ? void 0 : _c.children) == null ? void 0 : _d.length) && props.fitContent ? /* @__PURE__ */ _jsxC(Slot, null, 3, "0A_2") : null,
      !props.fitContent && props.children ? /* @__PURE__ */ _jsxQ("div", null, {
        class: "div-Image-2"
      }, /* @__PURE__ */ _jsxC(Slot, null, 3, "0A_3"), 1, "0A_4") : null
    ]
  }, 1, "0A_5");
}, "Image_component_LRxDkFa1EfU"));
const STYLES = `
.img-Image {
  opacity: 1;
  transition: opacity 0.2s ease-in-out;
}
.div-Image {
  width: 100%;
  pointer-events: none;
  font-size: 0;
}
.div-Image-2 {
  display: flex;
  flex-direction: column;
  align-items: stretch;
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}
`;
const SectionComponent = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  return /* @__PURE__ */ _jsxS("section", {
    ...props.attributes,
    children: /* @__PURE__ */ _jsxC(Slot, null, 3, "2Y_0"),
    style: {
      width: "100%",
      alignSelf: "stretch",
      flexGrow: 1,
      boxSizing: "border-box",
      maxWidth: props.maxWidth || 1200,
      display: "flex",
      flexDirection: "column",
      alignItems: "stretch",
      marginLeft: "auto",
      marginRight: "auto"
    }
  }, null, 0, "2Y_1");
}, "SectionComponent_component_ZWF9iD5WeLg"));
const getTopLevelDomain = (host) => {
  if (host === "localhost" || host === "127.0.0.1")
    return host;
  const parts = host.split(".");
  if (parts.length > 2)
    return parts.slice(1).join(".");
  return host;
};
const getCookieSync = ({ name, canTrack }) => {
  var _a;
  try {
    if (!canTrack)
      return void 0;
    return (_a = document.cookie.split("; ").find((row) => row.startsWith(`${name}=`))) == null ? void 0 : _a.split("=")[1];
  } catch (err) {
    logger.warn("[COOKIE] GET error: ", (err == null ? void 0 : err.message) || err);
    return void 0;
  }
};
const getCookie = async (args) => getCookieSync(args);
const stringifyCookie = (cookie) => cookie.map(([key, value]) => value ? `${key}=${value}` : key).filter(checkIsDefined).join("; ");
const SECURE_CONFIG = [
  [
    "secure",
    ""
  ],
  [
    "SameSite",
    "None"
  ]
];
const createCookieString = ({ name, value, expires }) => {
  const secure = isBrowser() ? location.protocol === "https:" : true;
  const secureObj = secure ? SECURE_CONFIG : [
    []
  ];
  const expiresObj = expires ? [
    [
      "expires",
      expires.toUTCString()
    ]
  ] : [
    []
  ];
  const cookieValue = [
    [
      name,
      value
    ],
    ...expiresObj,
    [
      "path",
      "/"
    ],
    [
      "domain",
      getTopLevelDomain(window.location.hostname)
    ],
    ...secureObj
  ];
  const cookie = stringifyCookie(cookieValue);
  return cookie;
};
const setCookie = async ({ name, value, expires, canTrack }) => {
  try {
    if (!canTrack)
      return;
    const cookie = createCookieString({
      name,
      value,
      expires
    });
    document.cookie = cookie;
  } catch (err) {
    logger.warn("[COOKIE] SET error: ", (err == null ? void 0 : err.message) || err);
  }
};
const BUILDER_STORE_PREFIX = "builder.tests";
const getContentTestKey = (id) => `${BUILDER_STORE_PREFIX}.${id}`;
const getContentVariationCookie = ({ contentId }) => getCookie({
  name: getContentTestKey(contentId),
  canTrack: true
});
const getContentVariationCookieSync = ({ contentId }) => getCookieSync({
  name: getContentTestKey(contentId),
  canTrack: true
});
const setContentVariationCookie = ({ contentId, value }) => setCookie({
  name: getContentTestKey(contentId),
  value,
  canTrack: true
});
const checkIsBuilderContentWithVariations = (item) => checkIsDefined(item.id) && checkIsDefined(item.variations) && Object.keys(item.variations).length > 0;
const getRandomVariationId = ({ id, variations }) => {
  var _a;
  let n = 0;
  const random = Math.random();
  for (const id2 in variations) {
    const testRatio = (_a = variations[id2]) == null ? void 0 : _a.testRatio;
    n += testRatio;
    if (random < n)
      return id2;
  }
  return id;
};
const getAndSetVariantId = (args) => {
  const randomVariationId = getRandomVariationId(args);
  setContentVariationCookie({
    contentId: args.id,
    value: randomVariationId
  }).catch((err) => {
    logger.error("could not store A/B test variation: ", err);
  });
  return randomVariationId;
};
const getTestFields = ({ item, testGroupId }) => {
  const variationValue = item.variations[testGroupId];
  if (testGroupId === item.id || // handle edge-case where `testGroupId` points to non-existing variation
  !variationValue)
    return {
      testVariationId: item.id,
      testVariationName: "Default"
    };
  else
    return {
      data: variationValue.data,
      testVariationId: variationValue.id,
      testVariationName: variationValue.name || (variationValue.id === item.id ? "Default" : "")
    };
};
const handleABTestingSync = ({ item, canTrack }) => {
  if (!canTrack)
    return item;
  if (!item)
    return void 0;
  if (!checkIsBuilderContentWithVariations(item))
    return item;
  const testGroupId = getContentVariationCookieSync({
    contentId: item.id
  }) || getAndSetVariantId({
    variations: item.variations,
    id: item.id
  });
  const variationValue = getTestFields({
    item,
    testGroupId
  });
  return {
    ...item,
    ...variationValue
  };
};
const handleABTesting = async ({ item, canTrack }) => {
  if (!canTrack)
    return item;
  if (!checkIsBuilderContentWithVariations(item))
    return item;
  const cookieValue = await getContentVariationCookie({
    contentId: item.id
  });
  const testGroupId = cookieValue || getAndSetVariantId({
    variations: item.variations,
    id: item.id
  });
  const variationValue = getTestFields({
    item,
    testGroupId
  });
  return {
    ...item,
    ...variationValue
  };
};
const getDefaultCanTrack = (canTrack) => checkIsDefined(canTrack) ? canTrack : true;
const componentInfo$a = {
  name: "Core:Button",
  image: "https://cdn.builder.io/api/v1/image/assets%2FIsxPKMo2gPRRKeakUztj1D6uqed2%2F81a15681c3e74df09677dfc57a615b13",
  defaultStyles: {
    // TODO: make min width more intuitive and set one
    appearance: "none",
    paddingTop: "15px",
    paddingBottom: "15px",
    paddingLeft: "25px",
    paddingRight: "25px",
    backgroundColor: "#000000",
    color: "white",
    borderRadius: "4px",
    textAlign: "center",
    cursor: "pointer"
  },
  inputs: [
    {
      name: "text",
      type: "text",
      defaultValue: "Click me!",
      bubble: true
    },
    {
      name: "link",
      type: "url",
      bubble: true
    },
    {
      name: "openLinkInNewTab",
      type: "boolean",
      defaultValue: false,
      friendlyName: "Open link in new tab"
    }
  ],
  static: true,
  noWrap: true
};
const componentInfo$9 = {
  // TODO: ways to statically preprocess JSON for references, functions, etc
  name: "Columns",
  isRSC: true,
  inputs: [
    {
      name: "columns",
      type: "array",
      broadcast: true,
      subFields: [
        {
          name: "blocks",
          type: "array",
          hideFromUI: true,
          defaultValue: [
            {
              "@type": "@builder.io/sdk:Element",
              responsiveStyles: {
                large: {
                  display: "flex",
                  flexDirection: "column",
                  alignItems: "stretch",
                  flexShrink: "0",
                  position: "relative",
                  marginTop: "30px",
                  textAlign: "center",
                  lineHeight: "normal",
                  height: "auto",
                  minHeight: "20px",
                  minWidth: "20px",
                  overflow: "hidden"
                }
              },
              component: {
                name: "Image",
                options: {
                  image: "https://builder.io/api/v1/image/assets%2Fpwgjf0RoYWbdnJSbpBAjXNRMe9F2%2Ffb27a7c790324294af8be1c35fe30f4d",
                  backgroundPosition: "center",
                  backgroundSize: "cover",
                  aspectRatio: 0.7004048582995948
                }
              }
            },
            {
              "@type": "@builder.io/sdk:Element",
              responsiveStyles: {
                large: {
                  display: "flex",
                  flexDirection: "column",
                  alignItems: "stretch",
                  flexShrink: "0",
                  position: "relative",
                  marginTop: "30px",
                  textAlign: "center",
                  lineHeight: "normal",
                  height: "auto"
                }
              },
              component: {
                name: "Text",
                options: {
                  text: "<p>Enter some text...</p>"
                }
              }
            }
          ]
        },
        {
          name: "width",
          type: "number",
          hideFromUI: true,
          helperText: "Width %, e.g. set to 50 to fill half of the space"
        },
        {
          name: "link",
          type: "url",
          helperText: "Optionally set a url that clicking this column will link to"
        }
      ],
      defaultValue: [
        {
          blocks: [
            {
              "@type": "@builder.io/sdk:Element",
              responsiveStyles: {
                large: {
                  display: "flex",
                  flexDirection: "column",
                  alignItems: "stretch",
                  flexShrink: "0",
                  position: "relative",
                  marginTop: "30px",
                  textAlign: "center",
                  lineHeight: "normal",
                  height: "auto",
                  minHeight: "20px",
                  minWidth: "20px",
                  overflow: "hidden"
                }
              },
              component: {
                name: "Image",
                options: {
                  image: "https://builder.io/api/v1/image/assets%2Fpwgjf0RoYWbdnJSbpBAjXNRMe9F2%2Ffb27a7c790324294af8be1c35fe30f4d",
                  backgroundPosition: "center",
                  backgroundSize: "cover",
                  aspectRatio: 0.7004048582995948
                }
              }
            },
            {
              "@type": "@builder.io/sdk:Element",
              responsiveStyles: {
                large: {
                  display: "flex",
                  flexDirection: "column",
                  alignItems: "stretch",
                  flexShrink: "0",
                  position: "relative",
                  marginTop: "30px",
                  textAlign: "center",
                  lineHeight: "normal",
                  height: "auto"
                }
              },
              component: {
                name: "Text",
                options: {
                  text: "<p>Enter some text...</p>"
                }
              }
            }
          ]
        },
        {
          blocks: [
            {
              "@type": "@builder.io/sdk:Element",
              responsiveStyles: {
                large: {
                  display: "flex",
                  flexDirection: "column",
                  alignItems: "stretch",
                  flexShrink: "0",
                  position: "relative",
                  marginTop: "30px",
                  textAlign: "center",
                  lineHeight: "normal",
                  height: "auto",
                  minHeight: "20px",
                  minWidth: "20px",
                  overflow: "hidden"
                }
              },
              component: {
                name: "Image",
                options: {
                  image: "https://builder.io/api/v1/image/assets%2Fpwgjf0RoYWbdnJSbpBAjXNRMe9F2%2Ffb27a7c790324294af8be1c35fe30f4d",
                  backgroundPosition: "center",
                  backgroundSize: "cover",
                  aspectRatio: 0.7004048582995948
                }
              }
            },
            {
              "@type": "@builder.io/sdk:Element",
              responsiveStyles: {
                large: {
                  display: "flex",
                  flexDirection: "column",
                  alignItems: "stretch",
                  flexShrink: "0",
                  position: "relative",
                  marginTop: "30px",
                  textAlign: "center",
                  lineHeight: "normal",
                  height: "auto"
                }
              },
              component: {
                name: "Text",
                options: {
                  text: "<p>Enter some text...</p>"
                }
              }
            }
          ]
        }
      ],
      onChange: (options) => {
        function clearWidths() {
          columns.forEach((col) => {
            col.delete("width");
          });
        }
        const columns = options.get("columns");
        if (Array.isArray(columns)) {
          const containsColumnWithWidth = !!columns.find((col) => col.get("width"));
          if (containsColumnWithWidth) {
            const containsColumnWithoutWidth = !!columns.find((col) => !col.get("width"));
            if (containsColumnWithoutWidth)
              clearWidths();
            else {
              const sumWidths = columns.reduce((memo, col) => {
                return memo + col.get("width");
              }, 0);
              const widthsDontAddUp = sumWidths !== 100;
              if (widthsDontAddUp)
                clearWidths();
            }
          }
        }
      }
    },
    {
      name: "space",
      type: "number",
      defaultValue: 20,
      helperText: "Size of gap between columns",
      advanced: true
    },
    {
      name: "stackColumnsAt",
      type: "string",
      defaultValue: "tablet",
      helperText: "Convert horizontal columns to vertical at what device size",
      enum: [
        "tablet",
        "mobile",
        "never"
      ],
      advanced: true
    },
    {
      name: "reverseColumnsWhenStacked",
      type: "boolean",
      defaultValue: false,
      helperText: "When stacking columns for mobile devices, reverse the ordering",
      advanced: true
    }
  ]
};
const componentInfo$8 = {
  name: "Fragment",
  static: true,
  hidden: true,
  canHaveChildren: true,
  noWrap: true
};
const componentInfo$7 = {
  name: "Image",
  static: true,
  image: "https://firebasestorage.googleapis.com/v0/b/builder-3b0a2.appspot.com/o/images%2Fbaseline-insert_photo-24px.svg?alt=media&token=4e5d0ef4-f5e8-4e57-b3a9-38d63a9b9dc4",
  defaultStyles: {
    position: "relative",
    minHeight: "20px",
    minWidth: "20px",
    overflow: "hidden"
  },
  canHaveChildren: true,
  inputs: [
    {
      name: "image",
      type: "file",
      bubble: true,
      allowedFileTypes: [
        "jpeg",
        "jpg",
        "png",
        "svg"
      ],
      required: true,
      defaultValue: "https://cdn.builder.io/api/v1/image/assets%2FYJIGb4i01jvw0SRdL5Bt%2F72c80f114dc149019051b6852a9e3b7a",
      onChange: (options) => {
        const DEFAULT_ASPECT_RATIO = 0.7041;
        options.delete("srcset");
        options.delete("noWebp");
        function loadImage(url, timeout = 6e4) {
          return new Promise((resolve, reject) => {
            const img = document.createElement("img");
            let loaded = false;
            img.onload = () => {
              loaded = true;
              resolve(img);
            };
            img.addEventListener("error", (event) => {
              console.warn("Image load failed", event.error);
              reject(event.error);
            });
            img.src = url;
            setTimeout(() => {
              if (!loaded)
                reject(new Error("Image load timed out"));
            }, timeout);
          });
        }
        function round2(num) {
          return Math.round(num * 1e3) / 1e3;
        }
        const value = options.get("image");
        const aspectRatio = options.get("aspectRatio");
        fetch(value).then((res) => res.blob()).then((blob) => {
          if (blob.type.includes("svg"))
            options.set("noWebp", true);
        });
        if (value && (!aspectRatio || aspectRatio === DEFAULT_ASPECT_RATIO))
          return loadImage(value).then((img) => {
            const possiblyUpdatedAspectRatio = options.get("aspectRatio");
            if (options.get("image") === value && (!possiblyUpdatedAspectRatio || possiblyUpdatedAspectRatio === DEFAULT_ASPECT_RATIO)) {
              if (img.width && img.height) {
                options.set("aspectRatio", round2(img.height / img.width));
                options.set("height", img.height);
                options.set("width", img.width);
              }
            }
          });
      }
    },
    {
      name: "backgroundSize",
      type: "text",
      defaultValue: "cover",
      enum: [
        {
          label: "contain",
          value: "contain",
          helperText: "The image should never get cropped"
        },
        {
          label: "cover",
          value: "cover",
          helperText: "The image should fill it's box, cropping when needed"
        }
      ]
    },
    {
      name: "backgroundPosition",
      type: "text",
      defaultValue: "center",
      enum: [
        "center",
        "top",
        "left",
        "right",
        "bottom",
        "top left",
        "top right",
        "bottom left",
        "bottom right"
      ]
    },
    {
      name: "altText",
      type: "string",
      helperText: "Text to display when the user has images off"
    },
    {
      name: "height",
      type: "number",
      hideFromUI: true
    },
    {
      name: "width",
      type: "number",
      hideFromUI: true
    },
    {
      name: "sizes",
      type: "string",
      hideFromUI: true
    },
    {
      name: "srcset",
      type: "string",
      hideFromUI: true
    },
    {
      name: "lazy",
      type: "boolean",
      defaultValue: true,
      hideFromUI: true
    },
    {
      name: "fitContent",
      type: "boolean",
      helperText: "When child blocks are provided, fit to them instead of using the image's aspect ratio",
      defaultValue: true
    },
    {
      name: "aspectRatio",
      type: "number",
      helperText: "This is the ratio of height/width, e.g. set to 1.5 for a 300px wide and 200px tall photo. Set to 0 to not force the image to maintain it's aspect ratio",
      advanced: true,
      defaultValue: 0.7041
    }
  ]
};
const componentInfo$6 = {
  name: "Core:Section",
  static: true,
  image: "https://cdn.builder.io/api/v1/image/assets%2FIsxPKMo2gPRRKeakUztj1D6uqed2%2F682efef23ace49afac61748dd305c70a",
  inputs: [
    {
      name: "maxWidth",
      type: "number",
      defaultValue: 1200
    },
    {
      name: "lazyLoad",
      type: "boolean",
      defaultValue: false,
      advanced: true,
      description: "Only render this section when in view"
    }
  ],
  defaultStyles: {
    paddingLeft: "20px",
    paddingRight: "20px",
    paddingTop: "50px",
    paddingBottom: "50px",
    marginTop: "0px",
    width: "100vw",
    marginLeft: "calc(50% - 50vw)"
  },
  canHaveChildren: true,
  defaultChildren: [
    {
      "@type": "@builder.io/sdk:Element",
      responsiveStyles: {
        large: {
          textAlign: "center"
        }
      },
      component: {
        name: "Text",
        options: {
          text: "<p><b>I am a section! My content keeps from getting too wide, so that it's easy to read even on big screens.</b></p><p>Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur</p>"
        }
      }
    }
  ]
};
const componentInfo$5 = {
  name: "Symbol",
  noWrap: true,
  static: true,
  isRSC: true,
  inputs: [
    {
      name: "symbol",
      type: "uiSymbol"
    },
    {
      name: "dataOnly",
      helperText: "Make this a data symbol that doesn't display any UI",
      type: "boolean",
      defaultValue: false,
      advanced: true,
      hideFromUI: true
    },
    {
      name: "inheritState",
      helperText: "Inherit the parent component state and data",
      type: "boolean",
      defaultValue: false,
      advanced: true
    },
    {
      name: "renderToLiquid",
      helperText: "Render this symbols contents to liquid. Turn off to fetch with javascript and use custom targeting",
      type: "boolean",
      defaultValue: false,
      advanced: true,
      hideFromUI: true
    },
    {
      name: "useChildren",
      hideFromUI: true,
      type: "boolean"
    }
  ]
};
const componentInfo$4 = {
  name: "Text",
  static: true,
  isRSC: true,
  image: "https://firebasestorage.googleapis.com/v0/b/builder-3b0a2.appspot.com/o/images%2Fbaseline-text_fields-24px%20(1).svg?alt=media&token=12177b73-0ee3-42ca-98c6-0dd003de1929",
  inputs: [
    {
      name: "text",
      type: "html",
      required: true,
      autoFocus: true,
      bubble: true,
      defaultValue: "Enter some text..."
    }
  ],
  defaultStyles: {
    lineHeight: "normal",
    height: "auto",
    textAlign: "center"
  }
};
const Text = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  return /* @__PURE__ */ _jsxQ("span", null, {
    class: "builder-text",
    dangerouslySetInnerHTML: _fnSignal((p0) => {
      var _a;
      return ((_a = p0.text) == null ? void 0 : _a.toString()) || "";
    }, [
      props
    ], 'p0.text?.toString()||""'),
    style: {
      outline: "none"
    }
  }, null, 3, "yO_0");
}, "Text_component_15p0cKUxgIE"));
const componentInfo$3 = {
  name: "Video",
  canHaveChildren: true,
  defaultStyles: {
    minHeight: "20px",
    minWidth: "20px"
  },
  image: "https://firebasestorage.googleapis.com/v0/b/builder-3b0a2.appspot.com/o/images%2Fbaseline-videocam-24px%20(1).svg?alt=media&token=49a84e4a-b20e-4977-a650-047f986874bb",
  inputs: [
    {
      name: "video",
      type: "file",
      allowedFileTypes: [
        "mp4"
      ],
      bubble: true,
      defaultValue: "https://firebasestorage.googleapis.com/v0/b/builder-3b0a2.appspot.com/o/assets%2FKQlEmWDxA0coC3PK6UvkrjwkIGI2%2F28cb070609f546cdbe5efa20e931aa4b?alt=media&token=912e9551-7a7c-4dfb-86b6-3da1537d1a7f",
      required: true
    },
    {
      name: "posterImage",
      type: "file",
      allowedFileTypes: [
        "jpeg",
        "png"
      ],
      helperText: "Image to show before the video plays"
    },
    {
      name: "autoPlay",
      type: "boolean",
      defaultValue: true
    },
    {
      name: "controls",
      type: "boolean",
      defaultValue: false
    },
    {
      name: "muted",
      type: "boolean",
      defaultValue: true
    },
    {
      name: "loop",
      type: "boolean",
      defaultValue: true
    },
    {
      name: "playsInline",
      type: "boolean",
      defaultValue: true
    },
    {
      name: "fit",
      type: "text",
      defaultValue: "cover",
      enum: [
        "contain",
        "cover",
        "fill",
        "auto"
      ]
    },
    {
      name: "preload",
      type: "text",
      defaultValue: "metadata",
      enum: [
        "auto",
        "metadata",
        "none"
      ]
    },
    {
      name: "fitContent",
      type: "boolean",
      helperText: "When child blocks are provided, fit to them instead of using the aspect ratio",
      defaultValue: true,
      advanced: true
    },
    {
      name: "position",
      type: "text",
      defaultValue: "center",
      enum: [
        "center",
        "top",
        "left",
        "right",
        "bottom",
        "top left",
        "top right",
        "bottom left",
        "bottom right"
      ]
    },
    {
      name: "height",
      type: "number",
      advanced: true
    },
    {
      name: "width",
      type: "number",
      advanced: true
    },
    {
      name: "aspectRatio",
      type: "number",
      advanced: true,
      defaultValue: 0.7004048582995948
    },
    {
      name: "lazyLoad",
      type: "boolean",
      helperText: 'Load this video "lazily" - as in only when a user scrolls near the video. Recommended for optmized performance and bandwidth consumption',
      defaultValue: true,
      advanced: true
    }
  ]
};
const Video = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  const videoProps = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [props2] = useLexicalScope();
    return {
      ...props2.autoPlay === true ? {
        autoPlay: true
      } : {},
      ...props2.muted === true ? {
        muted: true
      } : {},
      ...props2.controls === true ? {
        controls: true
      } : {},
      ...props2.loop === true ? {
        loop: true
      } : {},
      ...props2.playsInline === true ? {
        playsInline: true
      } : {}
    };
  }, "Video_component_videoProps_useComputed_60AadUGY06E", [
    props
  ]));
  const spreadProps = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [props2, videoProps2] = useLexicalScope();
    return {
      ...props2.attributes,
      ...videoProps2.value
    };
  }, "Video_component_spreadProps_useComputed_ZdLsx18NYH4", [
    props,
    videoProps
  ]));
  return /* @__PURE__ */ _jsxS("video", {
    ...spreadProps.value
  }, {
    poster: _fnSignal((p0) => p0.posterImage, [
      props
    ], "p0.posterImage"),
    preload: _fnSignal((p0) => p0.preload || "metadata", [
      props
    ], 'p0.preload||"metadata"'),
    src: _fnSignal((p0) => p0.video || "no-src", [
      props
    ], 'p0.video||"no-src"'),
    style: _fnSignal((p0) => {
      var _a;
      return {
        width: "100%",
        height: "100%",
        ...(_a = p0.attributes) == null ? void 0 : _a.style,
        objectFit: p0.fit,
        objectPosition: p0.position,
        // Hack to get object fit to work as expected and
        // not have the video overflow
        borderRadius: 1
      };
    }, [
      props
    ], '{width:"100%",height:"100%",...p0.attributes?.style,objectFit:p0.fit,objectPosition:p0.position,borderRadius:1}')
  }, 0, "j7_0");
}, "Video_component_qdcTZflYyoQ"));
const componentInfo$2 = {
  name: "Embed",
  static: true,
  inputs: [
    {
      name: "url",
      type: "url",
      required: true,
      defaultValue: "",
      helperText: "e.g. enter a youtube url, google map, etc",
      onChange: (options) => {
        const url = options.get("url");
        if (url) {
          options.set("content", "Loading...");
          const apiKey = "ae0e60e78201a3f2b0de4b";
          return fetch(`https://iframe.ly/api/iframely?url=${url}&api_key=${apiKey}`).then((res) => res.json()).then((data) => {
            if (options.get("url") === url) {
              if (data.html)
                options.set("content", data.html);
              else
                options.set("content", "Invalid url, please try another");
            }
          }).catch((_err) => {
            options.set("content", "There was an error embedding this URL, please try again or another URL");
          });
        } else
          options.delete("content");
      }
    },
    {
      name: "content",
      type: "html",
      defaultValue: '<div style="padding: 20px; text-align: center">(Choose an embed URL)<div>',
      hideFromUI: true
    }
  ]
};
const SCRIPT_MIME_TYPES = [
  "text/javascript",
  "application/javascript",
  "application/ecmascript"
];
const isJsScript = (script) => SCRIPT_MIME_TYPES.includes(script.type);
const findAndRunScripts$1 = function findAndRunScripts2(props, state, elem) {
  if (!elem.value || !elem.value.getElementsByTagName)
    return;
  const scripts = elem.value.getElementsByTagName("script");
  for (let i = 0; i < scripts.length; i++) {
    const script = scripts[i];
    if (script.src && !state.scriptsInserted.includes(script.src)) {
      state.scriptsInserted.push(script.src);
      const newScript = document.createElement("script");
      newScript.async = true;
      newScript.src = script.src;
      document.head.appendChild(newScript);
    } else if (isJsScript(script) && !state.scriptsRun.includes(script.innerText))
      try {
        state.scriptsRun.push(script.innerText);
        new Function(script.innerText)();
      } catch (error) {
        console.warn("`Embed`: Error running script:", error);
      }
  }
};
const Embed = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  const elem = useSignal();
  const state = useStore({
    ranInitFn: false,
    scriptsInserted: [],
    scriptsRun: []
  });
  useTaskQrl(/* @__PURE__ */ inlinedQrl(({ track: track2 }) => {
    const [elem2, props2, state2] = useLexicalScope();
    track2(() => elem2.value);
    track2(() => state2.ranInitFn);
    if (elem2.value && !state2.ranInitFn) {
      state2.ranInitFn = true;
      findAndRunScripts$1(props2, state2, elem2);
    }
  }, "Embed_component_useTask_bg7ez0XUtiM", [
    elem,
    props,
    state
  ]));
  return /* @__PURE__ */ _jsxQ("div", {
    ref: elem
  }, {
    class: "builder-embed",
    dangerouslySetInnerHTML: _fnSignal((p0) => p0.content, [
      props
    ], "p0.content")
  }, null, 3, "9r_0");
}, "Embed_component_Uji08ORjXbE"));
const ImgComponent = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  return /* @__PURE__ */ _jsxS("img", {
    ...props.attributes
  }, {
    alt: _fnSignal((p0) => p0.altText, [
      props
    ], "p0.altText"),
    src: _fnSignal((p0) => p0.imgSrc || p0.image, [
      props
    ], "p0.imgSrc||p0.image"),
    style: _fnSignal((p0) => ({
      objectFit: p0.backgroundSize || "cover",
      objectPosition: p0.backgroundPosition || "center"
    }), [
      props
    ], '{objectFit:p0.backgroundSize||"cover",objectPosition:p0.backgroundPosition||"center"}')
  }, 0, isEditing() && props.imgSrc || "default-key");
}, "ImgComponent_component_FXvIDBSffO8"));
const componentInfo$1 = {
  // friendlyName?
  name: "Raw:Img",
  hideFromInsertMenu: true,
  image: "https://firebasestorage.googleapis.com/v0/b/builder-3b0a2.appspot.com/o/images%2Fbaseline-insert_photo-24px.svg?alt=media&token=4e5d0ef4-f5e8-4e57-b3a9-38d63a9b9dc4",
  inputs: [
    {
      name: "image",
      bubble: true,
      type: "file",
      allowedFileTypes: [
        "jpeg",
        "jpg",
        "png",
        "svg",
        "gif",
        "webp"
      ],
      required: true
    }
  ],
  noWrap: true,
  static: true
};
const findAndRunScripts = function findAndRunScripts22(props, state, elem) {
  if (elem.value && elem.value.getElementsByTagName && typeof window !== "undefined") {
    const scripts = elem.value.getElementsByTagName("script");
    for (let i = 0; i < scripts.length; i++) {
      const script = scripts[i];
      if (script.src) {
        if (state.scriptsInserted.includes(script.src))
          continue;
        state.scriptsInserted.push(script.src);
        const newScript = document.createElement("script");
        newScript.async = true;
        newScript.src = script.src;
        document.head.appendChild(newScript);
      } else if (!script.type || [
        "text/javascript",
        "application/javascript",
        "application/ecmascript"
      ].includes(script.type)) {
        if (state.scriptsRun.includes(script.innerText))
          continue;
        try {
          state.scriptsRun.push(script.innerText);
          new Function(script.innerText)();
        } catch (error) {
          console.warn("`CustomCode`: Error running script:", error);
        }
      }
    }
  }
};
const CustomCode = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  const elem = useSignal();
  const state = useStore({
    scriptsInserted: [],
    scriptsRun: []
  });
  useVisibleTaskQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [elem2, props2, state2] = useLexicalScope();
    findAndRunScripts(props2, state2, elem2);
  }, "CustomCode_component_useVisibleTask_S5QgEQZj6YE", [
    elem,
    props,
    state
  ]));
  return /* @__PURE__ */ _jsxQ("div", {
    ref: elem
  }, {
    class: _fnSignal((p0) => "builder-custom-code" + (p0.replaceNodes ? " replace-nodes" : ""), [
      props
    ], '"builder-custom-code"+(p0.replaceNodes?" replace-nodes":"")'),
    dangerouslySetInnerHTML: _fnSignal((p0) => p0.code, [
      props
    ], "p0.code")
  }, null, 3, "bY_0");
}, "CustomCode_component_uYOSy7w7Zqw"));
const componentInfo = {
  name: "Custom Code",
  static: true,
  requiredPermissions: [
    "editCode"
  ],
  inputs: [
    {
      name: "code",
      type: "html",
      required: true,
      defaultValue: "<p>Hello there, I am custom HTML code!</p>",
      code: true
    },
    {
      name: "replaceNodes",
      type: "boolean",
      helperText: "Preserve server rendered dom nodes",
      advanced: true
    },
    {
      name: "scriptsClientOnly",
      type: "boolean",
      defaultValue: false,
      helperText: "Only print and run scripts on the client. Important when scripts influence DOM that could be replaced when client loads",
      advanced: true
    }
  ]
};
const getDefaultRegisteredComponents = () => [
  {
    component: Button,
    ...componentInfo$a
  },
  {
    component: Columns,
    ...componentInfo$9
  },
  {
    component: CustomCode,
    ...componentInfo
  },
  {
    component: Embed,
    ...componentInfo$2
  },
  {
    component: FragmentComponent,
    ...componentInfo$8
  },
  {
    component: Image,
    ...componentInfo$7
  },
  {
    component: ImgComponent,
    ...componentInfo$1
  },
  {
    component: SectionComponent,
    ...componentInfo$6
  },
  {
    component: Symbol$1,
    ...componentInfo$5
  },
  {
    component: Text,
    ...componentInfo$4
  },
  {
    component: Video,
    ...componentInfo$3
  }
];
const components = [];
const createRegisterComponentMessage = (info) => ({
  type: "builder.registerComponent",
  data: info
});
const serializeFn = (fnValue) => {
  const fnStr = fnValue.toString().trim();
  const appendFunction = !fnStr.startsWith("function") && !fnStr.startsWith("(");
  return `return (${appendFunction ? "function " : ""}${fnStr}).apply(this, arguments)`;
};
const serializeValue = (value) => typeof value === "function" ? serializeFn(value) : fastClone(value);
const serializeComponentInfo = ({ inputs, ...info }) => ({
  ...fastClone(info),
  inputs: inputs == null ? void 0 : inputs.map((input) => Object.entries(input).reduce((acc, [key, value]) => ({
    ...acc,
    [key]: serializeValue(value)
  }), {}))
});
const getVariants = (content) => Object.values((content == null ? void 0 : content.variations) || {}).map((variant) => ({
  ...variant,
  testVariationId: variant.id,
  id: content == null ? void 0 : content.id
}));
const checkShouldRunVariants = ({ canTrack, content }) => {
  const hasVariants = getVariants(content).length > 0;
  if (!hasVariants)
    return false;
  if (!canTrack)
    return false;
  if (isBrowser())
    return false;
  return true;
};
function bldrAbTest(contentId, variants, isHydrationTarget2) {
  var _a;
  function getAndSetVariantId2() {
    function setCookie2(name, value, days) {
      let expires = "";
      if (days) {
        const date = /* @__PURE__ */ new Date();
        date.setTime(date.getTime() + days * 864e5);
        expires = "; expires=" + date.toUTCString();
      }
      document.cookie = name + "=" + (value || "") + expires + "; path=/; Secure; SameSite=None";
    }
    function getCookie2(name) {
      const nameEQ = name + "=";
      const ca = document.cookie.split(";");
      for (let i = 0; i < ca.length; i++) {
        let c = ca[i];
        while (c.charAt(0) === " ")
          c = c.substring(1, c.length);
        if (c.indexOf(nameEQ) === 0)
          return c.substring(nameEQ.length, c.length);
      }
      return null;
    }
    const cookieName = `builder.tests.${contentId}`;
    const variantInCookie = getCookie2(cookieName);
    const availableIDs = variants.map((vr) => vr.id).concat(contentId);
    if (variantInCookie && availableIDs.includes(variantInCookie))
      return variantInCookie;
    let n = 0;
    const random = Math.random();
    for (let i = 0; i < variants.length; i++) {
      const variant = variants[i];
      const testRatio = variant.testRatio;
      n += testRatio;
      if (random < n) {
        setCookie2(cookieName, variant.id);
        return variant.id;
      }
    }
    setCookie2(cookieName, contentId);
    return contentId;
  }
  const winningVariantId = getAndSetVariantId2();
  const styleEl = (_a = document.currentScript) == null ? void 0 : _a.previousElementSibling;
  if (isHydrationTarget2) {
    styleEl.remove();
    const thisScriptEl = document.currentScript;
    thisScriptEl == null ? void 0 : thisScriptEl.remove();
  } else {
    const newStyleStr = variants.concat({
      id: contentId
    }).filter((variant) => variant.id !== winningVariantId).map((value) => {
      return `.variant-${value.id} {  display: none; }
        `;
    }).join("");
    styleEl.innerHTML = newStyleStr;
  }
}
function bldrCntntScrpt(variantContentId, defaultContentId, isHydrationTarget2) {
  var _a;
  if (!navigator.cookieEnabled)
    return;
  function getCookie2(name) {
    const nameEQ = name + "=";
    const ca = document.cookie.split(";");
    for (let i = 0; i < ca.length; i++) {
      let c = ca[i];
      while (c.charAt(0) === " ")
        c = c.substring(1, c.length);
      if (c.indexOf(nameEQ) === 0)
        return c.substring(nameEQ.length, c.length);
    }
    return null;
  }
  const cookieName = `builder.tests.${defaultContentId}`;
  const variantId = getCookie2(cookieName);
  const parentDiv = (_a = document.currentScript) == null ? void 0 : _a.parentElement;
  const variantIsDefaultContent = variantContentId === defaultContentId;
  if (variantId === variantContentId) {
    if (variantIsDefaultContent)
      return;
    parentDiv == null ? void 0 : parentDiv.removeAttribute("hidden");
    parentDiv == null ? void 0 : parentDiv.removeAttribute("aria-hidden");
  } else {
    if (variantIsDefaultContent) {
      if (isHydrationTarget2)
        parentDiv == null ? void 0 : parentDiv.remove();
      else {
        parentDiv == null ? void 0 : parentDiv.setAttribute("hidden", "true");
        parentDiv == null ? void 0 : parentDiv.setAttribute("aria-hidden", "true");
      }
    }
    return;
  }
  return;
}
const getIsHydrationTarget = (target) => target === "react" || target === "reactNative";
const isHydrationTarget = getIsHydrationTarget(TARGET);
const AB_TEST_FN_NAME = "builderIoAbTest";
const CONTENT_FN_NAME = "builderIoRenderContent";
const getScriptString = () => {
  const fnStr = bldrAbTest.toString().replace(/\s+/g, " ");
  const fnStr2 = bldrCntntScrpt.toString().replace(/\s+/g, " ");
  return `
  window.${AB_TEST_FN_NAME} = ${fnStr}
  window.${CONTENT_FN_NAME} = ${fnStr2}
  `;
};
const getVariantsScriptString = (variants, contentId) => {
  return `
  window.${AB_TEST_FN_NAME}("${contentId}",${JSON.stringify(variants)}, ${isHydrationTarget})`;
};
const getRenderContentScriptString = ({ contentId, variationId }) => {
  return `
  window.${CONTENT_FN_NAME}("${variationId}", "${contentId}", ${isHydrationTarget})`;
};
const InlinedScript = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  return /* @__PURE__ */ _jsxQ("script", null, {
    dangerouslySetInnerHTML: _fnSignal((p0) => p0.scriptStr, [
      props
    ], "p0.scriptStr"),
    id: _fnSignal((p0) => p0.id, [
      props
    ], "p0.id")
  }, null, 3, "WO_0");
}, "InlinedScript_component_hwThBdhA8rw"));
function getGlobalThis() {
  if (typeof globalThis !== "undefined")
    return globalThis;
  if (typeof window !== "undefined")
    return window;
  if (typeof global !== "undefined")
    return global;
  if (typeof self !== "undefined")
    return self;
  return globalThis;
}
function getFetch() {
  const globalFetch = getGlobalThis().fetch;
  if (typeof globalFetch === "undefined") {
    console.warn(`Builder SDK could not find a global fetch function. Make sure you have a polyfill for fetch in your project. 
      For more information, read https://github.com/BuilderIO/this-package-uses-fetch`);
    throw new Error("Builder SDK could not find a global `fetch` function");
  }
  return globalFetch;
}
const fetch$1 = getFetch();
function flatten(object, path = null, separator = ".") {
  return Object.keys(object).reduce((acc, key) => {
    const value = object[key];
    const newPath = [
      path,
      key
    ].filter(Boolean).join(separator);
    const isObject = [
      typeof value === "object",
      value !== null,
      !(Array.isArray(value) && value.length === 0)
    ].every(Boolean);
    return isObject ? {
      ...acc,
      ...flatten(value, newPath, separator)
    } : {
      ...acc,
      [newPath]: value
    };
  }, {});
}
const BUILDER_SEARCHPARAMS_PREFIX = "builder.";
const BUILDER_OPTIONS_PREFIX = "options.";
const convertSearchParamsToQueryObject = (searchParams) => {
  const options = {};
  searchParams.forEach((value, key) => {
    options[key] = value;
  });
  return options;
};
const getBuilderSearchParams = (_options) => {
  if (!_options)
    return {};
  const options = normalizeSearchParams(_options);
  const newOptions = {};
  Object.keys(options).forEach((key) => {
    if (key.startsWith(BUILDER_SEARCHPARAMS_PREFIX)) {
      const trimmedKey = key.replace(BUILDER_SEARCHPARAMS_PREFIX, "").replace(BUILDER_OPTIONS_PREFIX, "");
      newOptions[trimmedKey] = options[key];
    }
  });
  return newOptions;
};
const getBuilderSearchParamsFromWindow = () => {
  if (!isBrowser())
    return {};
  const searchParams = new URLSearchParams(window.location.search);
  return getBuilderSearchParams(searchParams);
};
const normalizeSearchParams = (searchParams) => searchParams instanceof URLSearchParams ? convertSearchParamsToQueryObject(searchParams) : searchParams;
const DEFAULT_API_VERSION = "v3";
const generateContentUrl = (options) => {
  const { limit = 30, userAttributes, query, noTraverse = false, model, apiKey, includeRefs = true, enrich, locale, apiVersion = DEFAULT_API_VERSION } = options;
  if (!apiKey)
    throw new Error("Missing API key");
  if (![
    "v2",
    "v3"
  ].includes(apiVersion))
    throw new Error(`Invalid apiVersion: expected 'v2' or 'v3', received '${apiVersion}'`);
  const url = new URL(`https://cdn.builder.io/api/${apiVersion}/content/${model}?apiKey=${apiKey}&limit=${limit}&noTraverse=${noTraverse}&includeRefs=${includeRefs}${locale ? `&locale=${locale}` : ""}${enrich ? `&enrich=${enrich}` : ""}`);
  const queryOptions = {
    ...getBuilderSearchParamsFromWindow(),
    ...normalizeSearchParams(options.options || {})
  };
  const flattened = flatten(queryOptions);
  for (const key in flattened)
    url.searchParams.set(key, String(flattened[key]));
  if (userAttributes)
    url.searchParams.set("userAttributes", JSON.stringify(userAttributes));
  if (query) {
    const flattened2 = flatten({
      query
    });
    for (const key in flattened2)
      url.searchParams.set(key, JSON.stringify(flattened2[key]));
  }
  return url;
};
const checkContentHasResults = (content) => "results" in content;
async function getContent(options) {
  const allContent = await getAllContent({
    ...options,
    limit: 1
  });
  if (allContent)
    return allContent.results[0] || null;
  return null;
}
const fetchContent$1 = async (options) => {
  const url = generateContentUrl(options);
  const res = await fetch$1(url.href);
  const content = await res.json();
  return content;
};
const processContentResult = async (options, content, url = generateContentUrl(options)) => {
  const canTrack = getDefaultCanTrack(options.canTrack);
  url.search.includes(`preview=`);
  if (!canTrack)
    return content;
  if (!(isBrowser() || TARGET === "reactNative"))
    return content;
  try {
    const newResults = [];
    for (const item of content.results)
      newResults.push(await handleABTesting({
        item,
        canTrack
      }));
    content.results = newResults;
  } catch (e) {
    logger.error("Could not process A/B tests. ", e);
  }
  return content;
};
async function getAllContent(options) {
  try {
    const url = generateContentUrl(options);
    const content = await fetchContent$1(options);
    if (!checkContentHasResults(content)) {
      logger.error("Error fetching data. ", {
        url,
        content,
        options
      });
      return null;
    }
    return processContentResult(options, content);
  } catch (error) {
    logger.error("Error fetching data. ", error);
    return null;
  }
}
function isPreviewing() {
  if (!isBrowser())
    return false;
  if (isEditing())
    return false;
  return Boolean(location.search.indexOf("builder.preview=") !== -1);
}
function uuidv4() {
  return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function(c) {
    const r = Math.random() * 16 | 0, v = c == "x" ? r : r & 3 | 8;
    return v.toString(16);
  });
}
function uuid() {
  return uuidv4().replace(/-/g, "");
}
const SESSION_LOCAL_STORAGE_KEY = "builderSessionId";
const getSessionId = async ({ canTrack }) => {
  if (!canTrack)
    return void 0;
  const sessionId = await getCookie({
    name: SESSION_LOCAL_STORAGE_KEY,
    canTrack
  });
  if (checkIsDefined(sessionId))
    return sessionId;
  else {
    const newSessionId = createSessionId();
    setSessionId({
      id: newSessionId,
      canTrack
    });
    return newSessionId;
  }
};
const createSessionId = () => uuid();
const setSessionId = ({ id, canTrack }) => setCookie({
  name: SESSION_LOCAL_STORAGE_KEY,
  value: id,
  canTrack
});
const getLocalStorage = () => isBrowser() && typeof localStorage !== "undefined" ? localStorage : void 0;
const getLocalStorageItem = ({ key, canTrack }) => {
  var _a;
  try {
    if (canTrack)
      return (_a = getLocalStorage()) == null ? void 0 : _a.getItem(key);
    return void 0;
  } catch (err) {
    console.debug("[LocalStorage] GET error: ", err);
    return void 0;
  }
};
const setLocalStorageItem = ({ key, canTrack, value }) => {
  var _a;
  try {
    if (canTrack)
      (_a = getLocalStorage()) == null ? void 0 : _a.setItem(key, value);
  } catch (err) {
    console.debug("[LocalStorage] SET error: ", err);
  }
};
const VISITOR_LOCAL_STORAGE_KEY = "builderVisitorId";
const getVisitorId = ({ canTrack }) => {
  if (!canTrack)
    return void 0;
  const visitorId = getLocalStorageItem({
    key: VISITOR_LOCAL_STORAGE_KEY,
    canTrack
  });
  if (checkIsDefined(visitorId))
    return visitorId;
  else {
    const newVisitorId = createVisitorId();
    setVisitorId({
      id: newVisitorId,
      canTrack
    });
    return newVisitorId;
  }
};
const createVisitorId = () => uuid();
const setVisitorId = ({ id, canTrack }) => setLocalStorageItem({
  key: VISITOR_LOCAL_STORAGE_KEY,
  value: id,
  canTrack
});
const getLocation = () => {
  if (isBrowser()) {
    const parsedLocation = new URL(location.href);
    if (parsedLocation.pathname === "")
      parsedLocation.pathname = "/";
    return parsedLocation;
  } else {
    console.warn("Cannot get location for tracking in non-browser environment");
    return null;
  }
};
const getUserAgent = () => typeof navigator === "object" && navigator.userAgent || "";
const getUserAttributes = () => {
  const userAgent = getUserAgent();
  const isMobile = {
    Android() {
      return userAgent.match(/Android/i);
    },
    BlackBerry() {
      return userAgent.match(/BlackBerry/i);
    },
    iOS() {
      return userAgent.match(/iPhone|iPod/i);
    },
    Opera() {
      return userAgent.match(/Opera Mini/i);
    },
    Windows() {
      return userAgent.match(/IEMobile/i) || userAgent.match(/WPDesktop/i);
    },
    any() {
      return isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows() || TARGET === "reactNative";
    }
  };
  const isTablet = userAgent.match(/Tablet|iPad/i);
  const url = getLocation();
  return {
    urlPath: url == null ? void 0 : url.pathname,
    host: (url == null ? void 0 : url.host) || (url == null ? void 0 : url.hostname),
    device: isTablet ? "tablet" : isMobile.any() ? "mobile" : "desktop"
  };
};
const getTrackingEventData = async ({ canTrack }) => {
  if (!canTrack)
    return {
      visitorId: void 0,
      sessionId: void 0
    };
  const sessionId = await getSessionId({
    canTrack
  });
  const visitorId = getVisitorId({
    canTrack
  });
  return {
    sessionId,
    visitorId
  };
};
const createEvent = async ({ type: eventType, canTrack, apiKey, metadata, ...properties }) => ({
  type: eventType,
  data: {
    ...properties,
    metadata: {
      url: location.href,
      ...metadata
    },
    ...await getTrackingEventData({
      canTrack
    }),
    userAttributes: getUserAttributes(),
    ownerId: apiKey
  }
});
async function _track(eventProps) {
  if (!eventProps.apiKey) {
    logger.error("Missing API key for track call. Please provide your API key.");
    return;
  }
  if (!eventProps.canTrack)
    return;
  if (isEditing())
    return;
  if (!(isBrowser() || TARGET === "reactNative"))
    return;
  return fetch(`https://cdn.builder.io/api/v1/track`, {
    method: "POST",
    body: JSON.stringify({
      events: [
        await createEvent(eventProps)
      ]
    }),
    headers: {
      "content-type": "application/json"
    },
    mode: "cors"
  }).catch((err) => {
    console.error("Failed to track: ", err);
  });
}
const track = (args) => _track({
  ...args,
  canTrack: true
});
function round(num) {
  return Math.round(num * 1e3) / 1e3;
}
const findParentElement = (target, callback, checkElement = true) => {
  if (!(target instanceof HTMLElement))
    return null;
  let parent2 = checkElement ? target : target.parentElement;
  do {
    if (!parent2)
      return null;
    const matches = callback(parent2);
    if (matches)
      return parent2;
  } while (parent2 = parent2.parentElement);
  return null;
};
const findBuilderParent = (target) => findParentElement(target, (el) => {
  const id = el.getAttribute("builder-id") || el.id;
  return Boolean((id == null ? void 0 : id.indexOf("builder-")) === 0);
});
const computeOffset = ({ event, target }) => {
  const targetRect = target.getBoundingClientRect();
  const xOffset = event.clientX - targetRect.left;
  const yOffset = event.clientY - targetRect.top;
  const xRatio = round(xOffset / targetRect.width);
  const yRatio = round(yOffset / targetRect.height);
  return {
    x: xRatio,
    y: yRatio
  };
};
const getInteractionPropertiesForEvent = (event) => {
  const target = event.target;
  const targetBuilderElement = target && findBuilderParent(target);
  const builderId = (targetBuilderElement == null ? void 0 : targetBuilderElement.getAttribute("builder-id")) || (targetBuilderElement == null ? void 0 : targetBuilderElement.id);
  return {
    targetBuilderElement: builderId || void 0,
    metadata: {
      targetOffset: target ? computeOffset({
        event,
        target
      }) : void 0,
      builderTargetOffset: targetBuilderElement ? computeOffset({
        event,
        target: targetBuilderElement
      }) : void 0,
      builderElementIndex: targetBuilderElement && builderId ? [].slice.call(document.getElementsByClassName(builderId)).indexOf(targetBuilderElement) : void 0
    }
  };
};
const SDK_VERSION = "UNKNOWN_VERSION";
const registry = {};
function register(type, info) {
  let typeList = registry[type];
  if (!typeList)
    typeList = registry[type] = [];
  typeList.push(info);
  if (isBrowser()) {
    const message = {
      type: "builder.register",
      data: {
        type,
        info
      }
    };
    try {
      parent.postMessage(message, "*");
      if (parent !== window)
        window.postMessage(message, "*");
    } catch (err) {
      console.debug("Could not postmessage", err);
    }
  }
}
const registerInsertMenu = () => {
  register("insertMenu", {
    name: "_default",
    default: true,
    items: [
      {
        name: "Box"
      },
      {
        name: "Text"
      },
      {
        name: "Image"
      },
      {
        name: "Columns"
      },
      ...[
        {
          name: "Core:Section"
        },
        {
          name: "Core:Button"
        },
        {
          name: "Embed"
        },
        {
          name: "Custom Code"
        }
      ]
    ]
  });
};
let isSetupForEditing = false;
const setupBrowserForEditing = (options = {}) => {
  var _a, _b;
  if (isSetupForEditing)
    return;
  isSetupForEditing = true;
  if (isBrowser()) {
    (_a = window.parent) == null ? void 0 : _a.postMessage({
      type: "builder.sdkInfo",
      data: {
        target: TARGET,
        version: SDK_VERSION,
        supportsPatchUpdates: false,
        // Supports builder-model="..." attribute which is needed to
        // scope our '+ add block' button styling
        supportsAddBlockScoping: true,
        supportsCustomBreakpoints: true
      }
    }, "*");
    (_b = window.parent) == null ? void 0 : _b.postMessage({
      type: "builder.updateContent",
      data: {
        options
      }
    }, "*");
    window.addEventListener("message", ({ data }) => {
      var _a2, _b2;
      if (!(data == null ? void 0 : data.type))
        return;
      switch (data.type) {
        case "builder.evaluate": {
          const text = data.data.text;
          const args = data.data.arguments || [];
          const id = data.data.id;
          const fn = new Function(text);
          let result;
          let error = null;
          try {
            result = fn.apply(null, args);
          } catch (err) {
            error = err;
          }
          if (error)
            (_a2 = window.parent) == null ? void 0 : _a2.postMessage({
              type: "builder.evaluateError",
              data: {
                id,
                error: error.message
              }
            }, "*");
          else if (result && typeof result.then === "function")
            result.then((finalResult) => {
              var _a3;
              (_a3 = window.parent) == null ? void 0 : _a3.postMessage({
                type: "builder.evaluateResult",
                data: {
                  id,
                  result: finalResult
                }
              }, "*");
            }).catch(console.error);
          else
            (_b2 = window.parent) == null ? void 0 : _b2.postMessage({
              type: "builder.evaluateResult",
              data: {
                result,
                id
              }
            }, "*");
          break;
        }
      }
    });
  }
};
const mergeNewContent = function mergeNewContent2(props, state, elementRef, newContent) {
  var _a, _b, _c, _d, _e;
  const newContentValue = {
    ...props.builderContextSignal.content,
    ...newContent,
    data: {
      ...(_a = props.builderContextSignal.content) == null ? void 0 : _a.data,
      ...newContent == null ? void 0 : newContent.data
    },
    meta: {
      ...(_b = props.builderContextSignal.content) == null ? void 0 : _b.meta,
      ...newContent == null ? void 0 : newContent.meta,
      breakpoints: ((_c = newContent == null ? void 0 : newContent.meta) == null ? void 0 : _c.breakpoints) || ((_e = (_d = props.builderContextSignal.content) == null ? void 0 : _d.meta) == null ? void 0 : _e.breakpoints)
    }
  };
  props.builderContextSignal.content = newContentValue;
};
const processMessage = function processMessage2(props, state, elementRef, event) {
  var _a;
  const { data } = event;
  if (data)
    switch (data.type) {
      case "builder.configureSdk": {
        const messageContent = data.data;
        const { breakpoints, contentId } = messageContent;
        if (!contentId || contentId !== ((_a = props.builderContextSignal.content) == null ? void 0 : _a.id))
          return;
        if (breakpoints)
          mergeNewContent(props, state, elementRef, {
            meta: {
              breakpoints
            }
          });
        state.forceReRenderCount = state.forceReRenderCount + 1;
        break;
      }
      case "builder.contentUpdate": {
        const messageContent = data.data;
        const key = messageContent.key || messageContent.alias || messageContent.entry || messageContent.modelName;
        const contentData = messageContent.data;
        if (key === props.model) {
          mergeNewContent(props, state, elementRef, contentData);
          state.forceReRenderCount = state.forceReRenderCount + 1;
        }
        break;
      }
    }
};
const evaluateJsCode = function evaluateJsCode2(props, state, elementRef) {
  var _a, _b;
  const jsCode = (_b = (_a = props.builderContextSignal.content) == null ? void 0 : _a.data) == null ? void 0 : _b.jsCode;
  if (jsCode)
    evaluate({
      code: jsCode,
      context: props.context || {},
      localState: void 0,
      rootState: props.builderContextSignal.rootState,
      rootSetState: props.builderContextSignal.rootSetState
    });
};
const onClick = function onClick22(props, state, elementRef, event) {
  var _a, _b;
  if (props.builderContextSignal.content) {
    const variationId = (_a = props.builderContextSignal.content) == null ? void 0 : _a.testVariationId;
    const contentId = (_b = props.builderContextSignal.content) == null ? void 0 : _b.id;
    _track({
      type: "click",
      canTrack: state.canTrackToUse,
      contentId,
      apiKey: props.apiKey,
      variationId: variationId !== contentId ? variationId : void 0,
      ...getInteractionPropertiesForEvent(event),
      unique: !state.clicked
    });
  }
  if (!state.clicked)
    state.clicked = true;
};
const evalExpression = function evalExpression2(props, state, elementRef, expression) {
  return expression.replace(/{{([^}]+)}}/g, (_match, group) => evaluate({
    code: group,
    context: props.context || {},
    localState: void 0,
    rootState: props.builderContextSignal.rootState,
    rootSetState: props.builderContextSignal.rootSetState
  }));
};
const handleRequest = function handleRequest2(props, state, elementRef, { url, key }) {
  fetch$1(url).then((response) => response.json()).then((json) => {
    var _a, _b;
    const newState = {
      ...props.builderContextSignal.rootState,
      [key]: json
    };
    (_b = (_a = props.builderContextSignal).rootSetState) == null ? void 0 : _b.call(_a, newState);
    state.httpReqsData[key] = true;
  }).catch((err) => {
    console.error("error fetching dynamic data", url, err);
  });
};
const runHttpRequests = function runHttpRequests2(props, state, elementRef) {
  var _a, _b;
  const requests = ((_b = (_a = props.builderContextSignal.content) == null ? void 0 : _a.data) == null ? void 0 : _b.httpRequests) ?? {};
  Object.entries(requests).forEach(([key, url]) => {
    if (url && (!state.httpReqsData[key] || isEditing())) {
      const evaluatedUrl = evalExpression(props, state, elementRef, url);
      handleRequest(props, state, elementRef, {
        url: evaluatedUrl,
        key
      });
    }
  });
};
const emitStateUpdate = function emitStateUpdate2(props, state, elementRef) {
  if (isEditing())
    window.dispatchEvent(new CustomEvent("builder:component:stateChange", {
      detail: {
        state: props.builderContextSignal.rootState,
        ref: {
          name: props.model
        }
      }
    }));
};
const EnableEditor = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  _jsxBranch();
  const elementRef = useSignal();
  const state = useStore({
    canTrackToUse: checkIsDefined(props.canTrack) ? props.canTrack : true,
    clicked: false,
    forceReRenderCount: 0,
    httpReqsData: {},
    lastUpdated: 0,
    shouldSendResetCookie: false
  }, {
    deep: true
  });
  useContextProvider(builderContext, props.builderContextSignal);
  useVisibleTaskQrl(/* @__PURE__ */ inlinedQrl(() => {
    var _a, _b;
    const [elementRef2, props2, state2] = useLexicalScope();
    if (!props2.apiKey)
      logger.error("No API key provided to `RenderContent` component. This can cause issues. Please provide an API key using the `apiKey` prop.");
    if (isBrowser()) {
      if (isEditing()) {
        state2.forceReRenderCount = state2.forceReRenderCount + 1;
        window.addEventListener("message", processMessage.bind(null, props2, state2, elementRef2));
        registerInsertMenu();
        setupBrowserForEditing({
          ...props2.locale ? {
            locale: props2.locale
          } : {},
          ...props2.includeRefs ? {
            includeRefs: props2.includeRefs
          } : {},
          ...props2.enrich ? {
            enrich: props2.enrich
          } : {}
        });
        Object.values(props2.builderContextSignal.componentInfos).forEach((registeredComponent) => {
          var _a2;
          const message = createRegisterComponentMessage(registeredComponent);
          (_a2 = window.parent) == null ? void 0 : _a2.postMessage(message, "*");
        });
        window.addEventListener("builder:component:stateChangeListenerActivated", emitStateUpdate.bind(null, props2, state2, elementRef2));
      }
      if (props2.builderContextSignal.content) {
        const variationId = (_a = props2.builderContextSignal.content) == null ? void 0 : _a.testVariationId;
        const contentId = (_b = props2.builderContextSignal.content) == null ? void 0 : _b.id;
        _track({
          type: "impression",
          canTrack: state2.canTrackToUse,
          contentId,
          apiKey: props2.apiKey,
          variationId: variationId !== contentId ? variationId : void 0
        });
      }
      if (isPreviewing()) {
        const searchParams = new URL(location.href).searchParams;
        const searchParamPreviewModel = searchParams.get("builder.preview");
        const searchParamPreviewId = searchParams.get(`builder.preview.${searchParamPreviewModel}`);
        const previewApiKey = searchParams.get("apiKey") || searchParams.get("builder.space");
        if (searchParamPreviewModel === props2.model && previewApiKey === props2.apiKey && (!props2.content || searchParamPreviewId === props2.content.id))
          getContent({
            model: props2.model,
            apiKey: props2.apiKey,
            apiVersion: props2.builderContextSignal.apiVersion
          }).then((content) => {
            if (content)
              mergeNewContent(props2, state2, elementRef2, content);
          });
      }
      evaluateJsCode(props2);
      runHttpRequests(props2, state2, elementRef2);
      emitStateUpdate(props2);
    }
  }, "EnableEditor_component_useVisibleTask_Olaxc9jCOFk", [
    elementRef,
    props,
    state
  ]));
  useTaskQrl(/* @__PURE__ */ inlinedQrl(({ track: track2 }) => {
    const [elementRef2, props2, state2] = useLexicalScope();
    track2(() => props2.content);
    if (props2.content)
      mergeNewContent(props2, state2, elementRef2, props2.content);
  }, "EnableEditor_component_useTask_Nb2VI04qp0M", [
    elementRef,
    props,
    state
  ]));
  useTaskQrl(/* @__PURE__ */ inlinedQrl(({ track: track2 }) => {
    const [state2] = useLexicalScope();
    track2(() => state2.shouldSendResetCookie);
  }, "EnableEditor_component_useTask_1_m0y1Z9vk4eQ", [
    state
  ]));
  useTaskQrl(/* @__PURE__ */ inlinedQrl(({ track: track2 }) => {
    const [elementRef2, props2, state2] = useLexicalScope();
    track2(() => {
      var _a, _b;
      return (_b = (_a = props2.builderContextSignal.content) == null ? void 0 : _a.data) == null ? void 0 : _b.jsCode;
    });
    track2(() => props2.builderContextSignal.rootState);
    evaluateJsCode(props2);
  }, "EnableEditor_component_useTask_2_xVyv0tDqZLs", [
    elementRef,
    props,
    state
  ]));
  useTaskQrl(/* @__PURE__ */ inlinedQrl(({ track: track2 }) => {
    const [elementRef2, props2, state2] = useLexicalScope();
    track2(() => {
      var _a, _b;
      return (_b = (_a = props2.builderContextSignal.content) == null ? void 0 : _a.data) == null ? void 0 : _b.httpRequests;
    });
    runHttpRequests(props2, state2, elementRef2);
  }, "EnableEditor_component_useTask_3_bQ0e5LHZwWE", [
    elementRef,
    props,
    state
  ]));
  useTaskQrl(/* @__PURE__ */ inlinedQrl(({ track: track2 }) => {
    const [elementRef2, props2, state2] = useLexicalScope();
    track2(() => props2.builderContextSignal.rootState);
    emitStateUpdate(props2);
  }, "EnableEditor_component_useTask_4_moHYZG8uNVU", [
    elementRef,
    props,
    state
  ]));
  return /* @__PURE__ */ _jsxC(Fragment, {
    children: props.builderContextSignal.content ? /* @__PURE__ */ _jsxS("div", {
      ref: elementRef,
      ...props.showContent ? {} : {
        hidden: true,
        "aria-hidden": true
      },
      children: /* @__PURE__ */ _jsxC(Slot, null, 3, "06_0"),
      onClick$: /* @__PURE__ */ inlinedQrl((event) => {
        const [elementRef2, props2, state2] = useLexicalScope();
        return onClick(props2, state2, elementRef2, event);
      }, "EnableEditor_component__Fragment_div_onClick_1QOkLijjH0M", [
        elementRef,
        props,
        state
      ])
    }, {
      "builder-content-id": _fnSignal((p0) => {
        var _a;
        return (_a = p0.builderContextSignal.content) == null ? void 0 : _a.id;
      }, [
        props
      ], "p0.builderContextSignal.content?.id"),
      "builder-model": _fnSignal((p0) => p0.model, [
        props
      ], "p0.model"),
      class: _fnSignal((p0) => p0.classNameProp, [
        props
      ], "p0.classNameProp")
    }, 0, state.forceReRenderCount) : null
  }, 1, "06_1");
}, "EnableEditor_component_ko1mO8oaj8k"));
const getCssFromFont = (font) => {
  var _a;
  const family = font.family + (font.kind && !font.kind.includes("#") ? ", " + font.kind : "");
  const name = family.split(",")[0];
  const url = font.fileUrl ?? ((_a = font == null ? void 0 : font.files) == null ? void 0 : _a.regular);
  let str = "";
  if (url && family && name)
    str += `
@font-face {
font-family: "${family}";
src: local("${name}"), url('${url}') format('woff2');
font-display: fallback;
font-weight: 400;
}
      `.trim();
  if (font.files)
    for (const weight in font.files) {
      const isNumber = String(Number(weight)) === weight;
      if (!isNumber)
        continue;
      const weightUrl = font.files[weight];
      if (weightUrl && weightUrl !== url)
        str += `
@font-face {
font-family: "${family}";
src: url('${weightUrl}') format('woff2');
font-display: fallback;
font-weight: ${weight};
}
        `.trim();
    }
  return str;
};
const getFontCss = ({ customFonts }) => {
  var _a;
  return ((_a = customFonts == null ? void 0 : customFonts.map((font) => getCssFromFont(font))) == null ? void 0 : _a.join(" ")) || "";
};
const getCss = ({ cssCode, contentId }) => {
  if (!cssCode)
    return "";
  if (!contentId)
    return cssCode;
  return (cssCode == null ? void 0 : cssCode.replace(/&/g, `div[builder-content-id="${contentId}"]`)) || "";
};
const ContentStyles = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  const state = useStore({
    injectedStyles: `
${getCss({
      cssCode: props.cssCode,
      contentId: props.contentId
    })}
${getFontCss({
      customFonts: props.customFonts
    })}

.builder-text > p:first-of-type, .builder-text > .builder-paragraph:first-of-type {
  margin: 0;
}
.builder-text > p, .builder-text > .builder-paragraph {
  color: inherit;
  line-height: inherit;
  letter-spacing: inherit;
  font-weight: inherit;
  font-size: inherit;
  text-align: inherit;
  font-family: inherit;
}
`.trim()
  });
  return /* @__PURE__ */ _jsxC(InlinedStyles, {
    get styles() {
      return state.injectedStyles;
    },
    [_IMMUTABLE]: {
      styles: _fnSignal((p0) => p0.injectedStyles, [
        state
      ], "p0.injectedStyles")
    }
  }, 3, "8O_0");
}, "ContentStyles_component_Qbhu1myPWm0"));
const getContextStateInitialValue = ({ content, data, locale }) => {
  var _a, _b, _c;
  const defaultValues = {};
  (_b = (_a = content == null ? void 0 : content.data) == null ? void 0 : _a.inputs) == null ? void 0 : _b.forEach((input) => {
    var _a2;
    if (input.name && input.defaultValue !== void 0 && ((_a2 = content == null ? void 0 : content.data) == null ? void 0 : _a2.state) && content.data.state[input.name] === void 0)
      defaultValues[input.name] = input.defaultValue;
  });
  const stateToUse = {
    ...(_c = content == null ? void 0 : content.data) == null ? void 0 : _c.state,
    ...data,
    ...locale ? {
      locale
    } : {}
  };
  return {
    ...defaultValues,
    ...stateToUse
  };
};
const getContentInitialValue = ({ content, data }) => {
  return !content ? void 0 : {
    ...content,
    data: {
      ...content == null ? void 0 : content.data,
      ...data
    },
    meta: content == null ? void 0 : content.meta
  };
};
const ContentComponent = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  var _a, _b;
  _jsxBranch();
  const state = useStore({
    builderContextSignal: {
      content: getContentInitialValue({
        content: props.content,
        data: props.data
      }),
      localState: void 0,
      rootState: getContextStateInitialValue({
        content: props.content,
        data: props.data,
        locale: props.locale
      }),
      rootSetState: void 0,
      context: props.context || {},
      apiKey: props.apiKey,
      apiVersion: props.apiVersion,
      componentInfos: [
        ...getDefaultRegisteredComponents(),
        // While this `components` object is deprecated, we must maintain support for it.
        // Since users are able to override our default components, we need to make sure that we do not break such
        // existing usage.
        // This is why we spread `components` after the default Builder.io components, but before the `props.customComponents`,
        // which is the new standard way of providing custom components, and must therefore take precedence.
        ...components,
        ...props.customComponents || []
      ].reduce((acc, { component: _, ...info }) => ({
        ...acc,
        [info.name]: serializeComponentInfo(info)
      }), {}),
      inheritedStyles: {}
    },
    registeredComponents: [
      ...getDefaultRegisteredComponents(),
      // While this `components` object is deprecated, we must maintain support for it.
      // Since users are able to override our default components, we need to make sure that we do not break such
      // existing usage.
      // This is why we spread `components` after the default Builder.io components, but before the `props.customComponents`,
      // which is the new standard way of providing custom components, and must therefore take precedence.
      ...components,
      ...props.customComponents || []
    ].reduce((acc, { component, ...info }) => ({
      ...acc,
      [info.name]: {
        component,
        ...serializeComponentInfo(info)
      }
    }), {}),
    scriptStr: getRenderContentScriptString({
      // eslint-disable-next-line @typescript-eslint/no-non-null-assertion, @typescript-eslint/no-non-null-asserted-optional-chain
      variationId: (_a = props.content) == null ? void 0 : _a.testVariationId,
      // eslint-disable-next-line @typescript-eslint/no-non-null-assertion, @typescript-eslint/no-non-null-asserted-optional-chain
      contentId: (_b = props.content) == null ? void 0 : _b.id
    })
  }, {
    deep: true
  });
  useContextProvider(ComponentsContext, useStore({
    registeredComponents: state.registeredComponents
  }));
  return /* @__PURE__ */ _jsxC(EnableEditor, {
    get content() {
      return props.content;
    },
    get model() {
      return props.model;
    },
    get context() {
      return props.context;
    },
    get apiKey() {
      return props.apiKey;
    },
    get canTrack() {
      return props.canTrack;
    },
    get locale() {
      return props.locale;
    },
    get includeRefs() {
      return props.includeRefs;
    },
    get enrich() {
      return props.enrich;
    },
    get classNameProp() {
      return props.classNameProp;
    },
    get showContent() {
      return props.showContent;
    },
    get builderContextSignal() {
      return state.builderContextSignal;
    },
    children: [
      props.isSsrAbTest ? /* @__PURE__ */ _jsxC(InlinedScript, {
        get scriptStr() {
          return state.scriptStr;
        },
        [_IMMUTABLE]: {
          scriptStr: _fnSignal((p0) => p0.scriptStr, [
            state
          ], "p0.scriptStr")
        }
      }, 3, "LQ_0") : null,
      /* @__PURE__ */ _jsxC(ContentStyles, {
        get contentId() {
          var _a2;
          return (_a2 = state.builderContextSignal.content) == null ? void 0 : _a2.id;
        },
        get cssCode() {
          var _a2, _b2;
          return (_b2 = (_a2 = state.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.cssCode;
        },
        get customFonts() {
          var _a2, _b2;
          return (_b2 = (_a2 = state.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.customFonts;
        },
        [_IMMUTABLE]: {
          contentId: _fnSignal((p0) => {
            var _a2;
            return (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.id;
          }, [
            state
          ], "p0.builderContextSignal.content?.id"),
          cssCode: _fnSignal((p0) => {
            var _a2, _b2;
            return (_b2 = (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.cssCode;
          }, [
            state
          ], "p0.builderContextSignal.content?.data?.cssCode"),
          customFonts: _fnSignal((p0) => {
            var _a2, _b2;
            return (_b2 = (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.customFonts;
          }, [
            state
          ], "p0.builderContextSignal.content?.data?.customFonts")
        }
      }, 3, "LQ_1"),
      /* @__PURE__ */ _jsxC(Blocks, {
        get blocks() {
          var _a2, _b2;
          return (_b2 = (_a2 = state.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.blocks;
        },
        get context() {
          return state.builderContextSignal;
        },
        get registeredComponents() {
          return state.registeredComponents;
        },
        [_IMMUTABLE]: {
          blocks: _fnSignal((p0) => {
            var _a2, _b2;
            return (_b2 = (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.blocks;
          }, [
            state
          ], "p0.builderContextSignal.content?.data?.blocks"),
          context: _fnSignal((p0) => p0.builderContextSignal, [
            state
          ], "p0.builderContextSignal"),
          registeredComponents: _fnSignal((p0) => p0.registeredComponents, [
            state
          ], "p0.registeredComponents")
        }
      }, 3, "LQ_2")
    ],
    [_IMMUTABLE]: {
      apiKey: _fnSignal((p0) => p0.apiKey, [
        props
      ], "p0.apiKey"),
      builderContextSignal: _fnSignal((p0) => p0.builderContextSignal, [
        state
      ], "p0.builderContextSignal"),
      canTrack: _fnSignal((p0) => p0.canTrack, [
        props
      ], "p0.canTrack"),
      classNameProp: _fnSignal((p0) => p0.classNameProp, [
        props
      ], "p0.classNameProp"),
      content: _fnSignal((p0) => p0.content, [
        props
      ], "p0.content"),
      context: _fnSignal((p0) => p0.context, [
        props
      ], "p0.context"),
      enrich: _fnSignal((p0) => p0.enrich, [
        props
      ], "p0.enrich"),
      includeRefs: _fnSignal((p0) => p0.includeRefs, [
        props
      ], "p0.includeRefs"),
      locale: _fnSignal((p0) => p0.locale, [
        props
      ], "p0.locale"),
      model: _fnSignal((p0) => p0.model, [
        props
      ], "p0.model"),
      showContent: _fnSignal((p0) => p0.showContent, [
        props
      ], "p0.showContent")
    }
  }, 1, "LQ_3");
}, "ContentComponent_component_HIsczUcxjCE"));
const ContentVariants = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  _jsxBranch();
  const state = useStore({
    shouldRenderVariants: checkShouldRunVariants({
      canTrack: getDefaultCanTrack(props.canTrack),
      content: props.content
    })
  });
  const variantScriptStr = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    var _a;
    const [props2] = useLexicalScope();
    return getVariantsScriptString(getVariants(props2.content).map((value) => ({
      id: value.testVariationId,
      testRatio: value.testRatio
    })), ((_a = props2.content) == null ? void 0 : _a.id) || "");
  }, "ContentVariants_component_variantScriptStr_useComputed_ldWqWafT8Ww", [
    props
  ]));
  const hideVariantsStyleString = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [props2] = useLexicalScope();
    return getVariants(props2.content).map((value) => `.variant-${value.testVariationId} { display: none; } `).join("");
  }, "ContentVariants_component_hideVariantsStyleString_useComputed_fQIC0fJqAl4", [
    props
  ]));
  const defaultContent = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    var _a;
    const [props2, state2] = useLexicalScope();
    return state2.shouldRenderVariants ? {
      ...props2.content,
      testVariationId: (_a = props2.content) == null ? void 0 : _a.id
    } : handleABTestingSync({
      item: props2.content,
      canTrack: getDefaultCanTrack(props2.canTrack)
    });
  }, "ContentVariants_component_defaultContent_useComputed_00q2HQsQPYc", [
    props,
    state
  ]));
  useVisibleTaskQrl(/* @__PURE__ */ inlinedQrl(() => {
  }, "ContentVariants_component_useVisibleTask_10cWAqcJ45I"));
  return /* @__PURE__ */ _jsxC(Fragment$1, {
    children: [
      !props.__isNestedRender && TARGET !== "reactNative" ? /* @__PURE__ */ _jsxC(InlinedScript, {
        get scriptStr() {
          return getScriptString();
        },
        [_IMMUTABLE]: {
          scriptStr: _IMMUTABLE
        }
      }, 3, "XM_0") : null,
      state.shouldRenderVariants ? /* @__PURE__ */ _jsxC(Fragment, {
        children: [
          /* @__PURE__ */ _jsxC(InlinedStyles, {
            get id() {
              var _a;
              return `variants-styles-${(_a = props.content) == null ? void 0 : _a.id}`;
            },
            get styles() {
              return hideVariantsStyleString.value;
            },
            [_IMMUTABLE]: {
              id: _fnSignal((p0) => {
                var _a;
                return `variants-styles-${(_a = p0.content) == null ? void 0 : _a.id}`;
              }, [
                props
              ], "`variants-styles-${p0.content?.id}`"),
              styles: _fnSignal((p0) => p0.value, [
                hideVariantsStyleString
              ], "p0.value")
            }
          }, 3, "XM_1"),
          /* @__PURE__ */ _jsxC(InlinedScript, {
            get scriptStr() {
              return variantScriptStr.value;
            },
            [_IMMUTABLE]: {
              scriptStr: _fnSignal((p0) => p0.value, [
                variantScriptStr
              ], "p0.value")
            }
          }, 3, "XM_2"),
          (getVariants(props.content) || []).map(function(variant) {
            return /* @__PURE__ */ _jsxC(ContentComponent, {
              get content() {
                return variant;
              },
              showContent: false,
              get classNameProp() {
                return void 0;
              },
              get model() {
                return props.model;
              },
              get data() {
                return props.data;
              },
              get context() {
                return props.context;
              },
              get apiKey() {
                return props.apiKey;
              },
              get apiVersion() {
                return props.apiVersion;
              },
              get customComponents() {
                return props.customComponents;
              },
              get canTrack() {
                return props.canTrack;
              },
              get locale() {
                return props.locale;
              },
              get includeRefs() {
                return props.includeRefs;
              },
              get enrich() {
                return props.enrich;
              },
              get isSsrAbTest() {
                return state.shouldRenderVariants;
              },
              [_IMMUTABLE]: {
                apiKey: _fnSignal((p0) => p0.apiKey, [
                  props
                ], "p0.apiKey"),
                apiVersion: _fnSignal((p0) => p0.apiVersion, [
                  props
                ], "p0.apiVersion"),
                canTrack: _fnSignal((p0) => p0.canTrack, [
                  props
                ], "p0.canTrack"),
                classNameProp: _IMMUTABLE,
                content: _IMMUTABLE,
                context: _fnSignal((p0) => p0.context, [
                  props
                ], "p0.context"),
                customComponents: _fnSignal((p0) => p0.customComponents, [
                  props
                ], "p0.customComponents"),
                data: _fnSignal((p0) => p0.data, [
                  props
                ], "p0.data"),
                enrich: _fnSignal((p0) => p0.enrich, [
                  props
                ], "p0.enrich"),
                includeRefs: _fnSignal((p0) => p0.includeRefs, [
                  props
                ], "p0.includeRefs"),
                isSsrAbTest: _fnSignal((p0) => p0.shouldRenderVariants, [
                  state
                ], "p0.shouldRenderVariants"),
                locale: _fnSignal((p0) => p0.locale, [
                  props
                ], "p0.locale"),
                model: _fnSignal((p0) => p0.model, [
                  props
                ], "p0.model"),
                showContent: _IMMUTABLE
              }
            }, 3, variant.testVariationId);
          })
        ]
      }, 1, "XM_3") : null,
      /* @__PURE__ */ _jsxC(ContentComponent, {
        get content() {
          return defaultContent.value;
        },
        get classNameProp() {
          var _a;
          return `variant-${(_a = props.content) == null ? void 0 : _a.id}`;
        },
        showContent: true,
        get model() {
          return props.model;
        },
        get data() {
          return props.data;
        },
        get context() {
          return props.context;
        },
        get apiKey() {
          return props.apiKey;
        },
        get apiVersion() {
          return props.apiVersion;
        },
        get customComponents() {
          return props.customComponents;
        },
        get canTrack() {
          return props.canTrack;
        },
        get locale() {
          return props.locale;
        },
        get includeRefs() {
          return props.includeRefs;
        },
        get enrich() {
          return props.enrich;
        },
        get isSsrAbTest() {
          return state.shouldRenderVariants;
        },
        [_IMMUTABLE]: {
          apiKey: _fnSignal((p0) => p0.apiKey, [
            props
          ], "p0.apiKey"),
          apiVersion: _fnSignal((p0) => p0.apiVersion, [
            props
          ], "p0.apiVersion"),
          canTrack: _fnSignal((p0) => p0.canTrack, [
            props
          ], "p0.canTrack"),
          classNameProp: _fnSignal((p0) => {
            var _a;
            return `variant-${(_a = p0.content) == null ? void 0 : _a.id}`;
          }, [
            props
          ], "`variant-${p0.content?.id}`"),
          content: _fnSignal((p0) => p0.value, [
            defaultContent
          ], "p0.value"),
          context: _fnSignal((p0) => p0.context, [
            props
          ], "p0.context"),
          customComponents: _fnSignal((p0) => p0.customComponents, [
            props
          ], "p0.customComponents"),
          data: _fnSignal((p0) => p0.data, [
            props
          ], "p0.data"),
          enrich: _fnSignal((p0) => p0.enrich, [
            props
          ], "p0.enrich"),
          includeRefs: _fnSignal((p0) => p0.includeRefs, [
            props
          ], "p0.includeRefs"),
          isSsrAbTest: _fnSignal((p0) => p0.shouldRenderVariants, [
            state
          ], "p0.shouldRenderVariants"),
          locale: _fnSignal((p0) => p0.locale, [
            props
          ], "p0.locale"),
          model: _fnSignal((p0) => p0.model, [
            props
          ], "p0.model"),
          showContent: _IMMUTABLE
        }
      }, 3, "XM_4")
    ]
  }, 1, "XM_5");
}, "ContentVariants_component_4tFRiQMMEfM"));
const fetchContent = async ({ builderContextValue, symbol }) => {
  if ((symbol == null ? void 0 : symbol.model) && // This is a hack, we should not need to check for this, but it is needed for Svelte.
  (builderContextValue == null ? void 0 : builderContextValue.apiKey))
    return getContent({
      model: symbol.model,
      apiKey: builderContextValue.apiKey,
      apiVersion: builderContextValue.apiVersion,
      ...(symbol == null ? void 0 : symbol.entry) && {
        query: {
          id: symbol.entry
        }
      }
    }).catch((err) => {
      logger.error("Could not fetch symbol content: ", err);
      return void 0;
    });
  return void 0;
};
const setContent = function setContent2(props, state) {
  if (state.contentToUse)
    return;
  fetchContent({
    symbol: props.symbol,
    builderContextValue: props.builderContext
  }).then((newContent) => {
    if (newContent)
      state.contentToUse = newContent;
  });
};
const Symbol$1 = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  var _a;
  const className = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    var _a2, _b;
    const [props2] = useLexicalScope();
    return [
      props2.attributes.class,
      "builder-symbol",
      ((_a2 = props2.symbol) == null ? void 0 : _a2.inline) ? "builder-inline-symbol" : void 0,
      ((_b = props2.symbol) == null ? void 0 : _b.dynamic) || props2.dynamic ? "builder-dynamic-symbol" : void 0
    ].filter(Boolean).join(" ");
  }, "Symbol_component_className_useComputed_Wb6GqgtDHpE", [
    props
  ]));
  const state = useStore({
    contentToUse: (_a = props.symbol) == null ? void 0 : _a.content
  });
  useVisibleTaskQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [props2, state2] = useLexicalScope();
    setContent(props2, state2);
  }, "Symbol_component_useVisibleTask_oMPs8W5ZhwE", [
    props,
    state
  ]));
  useTaskQrl(/* @__PURE__ */ inlinedQrl(({ track: track2 }) => {
    const [props2, state2] = useLexicalScope();
    track2(() => props2.symbol);
    setContent(props2, state2);
  }, "Symbol_component_useTask_NIAWAC1bMBo", [
    props,
    state
  ]));
  return /* @__PURE__ */ _jsxS("div", {
    ...props.attributes,
    children: /* @__PURE__ */ _jsxC(ContentVariants, {
      get apiVersion() {
        return props.builderContext.apiVersion;
      },
      get apiKey() {
        return props.builderContext.apiKey;
      },
      get context() {
        return props.builderContext.context;
      },
      get customComponents() {
        return Object.values(props.builderComponents);
      },
      get data() {
        var _a2, _b, _c;
        return {
          ...(_a2 = props.symbol) == null ? void 0 : _a2.data,
          ...props.builderContext.localState,
          ...(_c = (_b = state.contentToUse) == null ? void 0 : _b.data) == null ? void 0 : _c.state
        };
      },
      get model() {
        var _a2;
        return (_a2 = props.symbol) == null ? void 0 : _a2.model;
      },
      get content() {
        return state.contentToUse;
      },
      [_IMMUTABLE]: {
        apiKey: _fnSignal((p0) => p0.builderContext.apiKey, [
          props
        ], "p0.builderContext.apiKey"),
        apiVersion: _fnSignal((p0) => p0.builderContext.apiVersion, [
          props
        ], "p0.builderContext.apiVersion"),
        content: _fnSignal((p0) => p0.contentToUse, [
          state
        ], "p0.contentToUse"),
        context: _fnSignal((p0) => p0.builderContext.context, [
          props
        ], "p0.builderContext.context"),
        customComponents: _fnSignal((p0) => Object.values(p0.builderComponents), [
          props
        ], "Object.values(p0.builderComponents)"),
        data: _fnSignal((p0, p1) => {
          var _a2, _b, _c;
          return {
            ...(_a2 = p0.symbol) == null ? void 0 : _a2.data,
            ...p0.builderContext.localState,
            ...(_c = (_b = p1.contentToUse) == null ? void 0 : _b.data) == null ? void 0 : _c.state
          };
        }, [
          props,
          state
        ], "{...p0.symbol?.data,...p0.builderContext.localState,...p1.contentToUse?.data?.state}"),
        model: _fnSignal((p0) => {
          var _a2;
          return (_a2 = p0.symbol) == null ? void 0 : _a2.model;
        }, [
          props
        ], "p0.symbol?.model")
      }
    }, 3, "Wt_0")
  }, {
    class: _fnSignal((p0) => p0.value, [
      className
    ], "p0.value")
  }, 0, "Wt_1");
}, "Symbol_component_WVvggdkUPdk"));
const settings = {};
function setEditorSettings(newSettings) {
  if (isBrowser()) {
    Object.assign(settings, newSettings);
    const message = {
      type: "builder.settingsChange",
      data: settings
    };
    parent.postMessage(message, "*");
  }
}
export {
  Button,
  Columns,
  FragmentComponent as Fragment,
  Image,
  Blocks as RenderBlocks,
  ContentVariants as RenderContent,
  SectionComponent as Section,
  Symbol$1 as Symbol,
  Text,
  Video,
  createRegisterComponentMessage,
  getAllContent,
  getBuilderSearchParams,
  getContent,
  isEditing,
  isPreviewing,
  processContentResult,
  register,
  setEditorSettings,
  track
};
